import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Sum_Some_Sines extends PApplet {


//  Adding sinusoids: by Steve Kranz, 2013-2014. This code is free and open.

// This original code is released on the MONTH DAYth, YEAR under 

// IMprovements:
// 1. Pie-chart visualization
// 2. Sound adaptation
// 3. Array list/ fix Num Sine selection
// 4. 

PImage testImage;
boolean showHelpImage = false;
boolean showAllControls = true;
boolean record = false; // for recording animation
boolean sinesOrCosines = false; // true = sines, false = cosines

boolean showHelpTextGlobal = false;
int helpX = 240 + 23;
int helpY = 107;
int helpW = 800 - 46;
int helpH = 40;

PFont mainFont, tutFont, tutNumFont;
PFont mainFontBold;
PFont titleFont;
PFont helpFont, helpTitleFont;

int count = 0; // for preventing toggle button from toggling more than once per click. 
int countFPA = 0; // for cycling through precalculated functions.
int dropCount = 0;
int prevDropCount = 0;
int raiseCount = 0;
int prevRaiseCount = 0;
int preSetCount = 0;
int prevPreSetCount =0;
int psCallCount = 0;

int numPreFunc;
float[][][] preFunc; // hold values for freq, phase and amplitude for functions like square wave, triangle wave, and cetera.


int[] binValues = {8,16,25,50,100,160,200,400,800};
int[] numSineValues = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 15, 20, 30, 40};

float acceleration;  // how fast the boxes fall





/////////// COLORS
int hueOscBackColor, hueOscTextColor, hueModBackColor, hueModTextColor;
int satOscBackColor, satOscTextColor, satModBackColor, satModTextColor;
int valOscBackColor, valOscTextColor, valModBackColor, valModTextColor;
int b0_color, b1_color, b2_color;
int t0_color, t1_color, t2_color;
int labelColor;
int sumColor;
int horzRuleColor, ggColor;
int dropRaiseColor;

int backgroundColor, foregroundColor;



// The tut buttons are clickable boxes that contain text-based instructions and explanations 
TutButton[] tutButtonArray;
int[] previousTutButtonStates;


Sine[] sines;

// Dynamic Sliders
SliderBar[] ampSliders;
SliderBar[] phaseSliders;
SliderBar[] freqSliders;

SliderBar[] deltaAmpSliders;
SliderBar[] deltaPhaseSliders;
SliderBar[] deltaFreqSliders;

// Static Sliders
SliderBar hueSlider, satSlider, brightSlider;
SliderBar hueIncSlider, satIncSlider, valIncSlider;
SliderBar hueTimeSlider, satTimeSlider, valTimeSlider;
SliderBar hueIncTimeSlider, satIncTimeSlider, valIncTimeSlider;

SliderBar globalPhase, globalAmp, globalFreq;

SliderBar binSlider;
SliderBar numSlider;

// Buttons
RectButton[] dropButtons;


BangButton boxesButton, strokeButton, lineButton, sumButton;

BangButton hueBang, satBang, valBang;
BangButton hueIncBang, satIncBang, valIncBang;
BangButton hueTimeBang, satTimeBang, valTimeBang;
BangButton hueIncTimeBang, satIncTimeBang, valIncTimeBang;


BangButton gravityBang;
BangButton stickyBang;
BangButton backgroundBang;

BangButton zenBang;
BangButton dropBang;
BangButton raiseBang;
BangButton helpBang;


// Buttons that act as LABELS!!!!
BangButton numButton, binButton, globalAmpButton, globalPhaseButton, globalFreqButton, globalGlobalButton, globalHorzRuleButton;
BangButton frameRateButton;
BangButton spaceButton, timeButton, spaceHRbutton, timeHRbutton;

// Sine controller modifiers
SliderControl ampSliderControl, phaseSliderControl, freqSliderControl;
SliderControl deltaAmpSliderControl, deltaPhaseSliderControl, deltaFreqSliderControl;

RadioButtons tutorialRadio;




float[] freqs;
float[] amps;
float[] baselines;
float[] phases;

// The base HSV values for the sliders, and the arrays for the individual sines. Value = Brightness.
float hueBase, satBase, valBase;
float hueInc, satInc, valInc;
float hueTimeBase, satTimeBase, valTimeBase;
float hueIncTimeBase, satIncTimeBase, valIncTimeBase;

//float hbCounter, sbCounter, vbCounter; // hueBase counter, etc.

float previousHue, previousSat, previousVal;
float prevHueInc, prevSatInc, prevValInc;
int previousAmpToggleCount;
int previousBackgroundState = 0;

float[] hues, sats, vals;



boolean[] isFalling;

int numSine = 20;
int maxnNumSine = max(numSineValues);

int previousNumSine;





float heightSine;//
float widthSine = 800;
float boxHeight; // The max height a sine can be

int sinesTranslateX = 240;
int sinesTranslateY = 175; 



// Hide/show booleans
boolean showFrameBox = true;
boolean showBinsBox = true;
boolean showNumBox = true;
boolean showGlobalSliders = true;
boolean showButtons = true;
boolean showButtons2 = true;
boolean showZen = true;
boolean showColorSliders = true;
boolean showTutButtons = true;
boolean showTut = true;
boolean showSines = true;

boolean showColor1 = true;
boolean showColor2 = true;
boolean showColor3 = true;
boolean showColor4 = true;

boolean showFreq = true;
boolean showPhase = true;
boolean showAmp = true;
boolean showDeltaFreq = true;
boolean showDeltaPhase = true;
boolean showDeltaAmp = true;
boolean showSpaceLabel = true;
boolean showTimeLabel = true;



float tempGlobalFreq;
float tempGlobalAmp;
float tempGlobalPhase;


// These arrays are to keep track of the current state of the sinusoids so that they are not reset when the number of sines is changed ()
// currently not implemented. 
float[] saveFreq, savePhase, saveAmp, saveDeltaFreq, saveDeltaPhase, saveDeltaAmp, saveDrop;


public void setup(){

  testImage = loadImage("quick_ref.jpg");
  

 String[] fontList = PFont.list();

 

  //noLoop();
  smooth();
  colorMode(HSB, 360, 100, 100, 100);

  size (1280, 720, JAVA2D);

  frameRate(30);

  mainFont = createFont("sans-serif", 12); 
  tutFont = createFont("sans-serif", 15);
  tutNumFont = createFont("sans-serif", 10);
  mainFontBold = createFont("sans-serif", 6);
  titleFont = createFont("sans-serif", 37);
  helpFont = createFont("sans-serif", 12);
  helpTitleFont = createFont("sans-serif", 30);
  textFont(mainFont);

  // println(fontList);
  

  setupButtons(300,10);
  gravityBang.state = 1; // set gravity to "medium" by default
  setupButtons2(815, 20); 
  setProgramColors();

  setupColorSliders(865, 25);

  setupSines();

  setupFrameBox(20, 5);
  setupSpaceTime();
  setupFrameBoxColors();
  
  setupColorButtons(865, 25);

  setupTutorial(475, 5, 330, 95, 10);
  setupPreFunc();
  
  setupHelpTextValues();
   
  
  
}




public void draw() {

 // println(showSines);
  textFont(mainFont);
  
  if (backgroundBang.state == 0) {
    background(0,0, 100);
    } else {
      background(0,0,0);
    } 

    drawingWarning(); // if all drawing options are turned off, signal to turn on "Fill"

 /// DEBUG
//text(frameCount, 30,130);

  for (int i = 0; i < numSine; i++) {   
      
      if (showFreq){   sines[i].setFreq(freqSliderControl.sliders[i].getValue() * tempGlobalFreq );  }
      if (showPhase){  sines[i].setPhase(phaseSliderControl.sliders[i].getValue() +  tempGlobalPhase * freqSliderControl.sliders[i].getValue() ); }
      if (showAmp){ sines[i].setAmplitude(map(ampSliderControl.sliders[i].getValue(), 0, 100, 0, boxHeight) * tempGlobalAmp); }  // map so amplitude values go from 0 - 100, but are drawn form 0 to max height a sine can be.    }


      if(showDeltaFreq)  {sines[i].setDeltaFreq(deltaFreqSliderControl.sliders[i].getValue());}
      if(showDeltaAmp)  {sines[i].setDeltaAmplitude(deltaAmpSliderControl.sliders[i].getValue());}
      if(showDeltaPhase) { sines[i].setDeltaPhase(deltaPhaseSliderControl.sliders[i].getValue());}


      
     
      

      sines[i].setBinNum(binValues[PApplet.parseInt(binSlider.getValue())]);

      if(isFalling[i] == true ){
         drop(i);
       }

    
    // where "if(showSines)" used to be
     if(showSines){
        pushMatrix();
        translate(sinesTranslateX, sinesTranslateY);
        sines[i].update();
    
    
        // Display the sine waves
        if (boxesButton.state != 0) {sines[i].displayBoxes();}
        if (strokeButton.state != 0) {sines[i].displayBoxStroke();}
        
        popMatrix();
     }

    
    

  }
  
    // Seperate loop that iterates through the sine waves so ensure correct layering
   for (int i = 0; i < numSine; i++) {
    

    pushMatrix();
    translate(sinesTranslateX, sinesTranslateY);
    if(showSines){
      if (lineButton.state == 1 || lineButton.state == 2 ) {sines[i].displayLine(3);}
    }
       popMatrix();
   

     // do not draw button for bottom-most sine
    if (i != 0){
    dropButtons[i].update();
    }
   }


if (frameCount < 910 && tutorialRadio.allOff() == true) {
  tutorialRadio.radioButtons[0].flashOn();
}

//background(0,0,100);

  //test1.display();

// draw background box for tool tips (AKA help);

drawHelpBackground();
/*
if(helpBang.state==1){
  fill(0,0,92);
  noStroke();
  rect(helpX, helpY, helpW, helpH);
}*/


// for Debugging ---------------
  fill(100);
 // text(frameCount, width-50, 50); 
 // text(frameRate, width-50, 70);
//----------------------------


//strokeWeight(1);
//stroke(color(0,50,90));
//line(0, 100, width, 100);

acceleration = .03f * gravityBang.returnValue();
  


/* Temproary rectangle for background measurements  
noStroke();
fill(330);
rect(sinesTranslateX, sinesTranslateY, widthSine, heightSine);
*/



 // General "static" sliders

 //globalAmp.update();

 // Toggle buttons
 
updateTutorial();
resetTutorial(); // to prevent a debugging nightmare...



 
 if (showButtons){
 updateButtons();
}

if (showButtons2){
  updateButtons2();
}

if (showZen){
  updateZen();
}


if (showFrameBox){
   updateFrameBox();
}

if (showBinsBox){
  updateBinsBox();
}

if (showNumBox){
  updateNumBox();
}


// Show/hide functions are built into these functions.
switchColorButtons();
 updateColorButtons();
 colorSlidersUpdate();






 numSine = numSineValues[PApplet.parseInt(numSlider.getValue())]; 
 

 // Have things changed around here?
 
 if(numSineChange()) { 
  setupSines();
  setupSpaceTime();
  setupFrameBoxColors();
  }



if (showSpaceLabel){
  updateSpace();
}

if (showTimeLabel){
  updateTime();
}
// if(ampAvgChange()) { ampAvgEval();}


 if( hueChange() || hueIncChange() ) { setupHues(hueBase); }
 if( satChange() || satIncChange() ) { setupSats(satBase); }
 if( valChange() || valIncChange() ) { setupVals(valBase); }

 if (backgroundBang.state != previousBackgroundState) {
  setProgramColors();
 }


// The sets of sliders that control the amplitude, phase and frequency of the sinusoids in both space and time.
if(showFreq)  {freqSliderControl.update(); }
if(showAmp)  {ampSliderControl.update();  }
if(showPhase) {phaseSliderControl.update();}

if(showDeltaFreq)  {deltaFreqSliderControl.update();}
if(showDeltaAmp)  {deltaAmpSliderControl.update();  }
if(showDeltaPhase) {deltaPhaseSliderControl.update();}







if (showGlobalSliders){
  updateGlobalBox();
}



// big ol' loop went here



  pushMatrix();
  translate(sinesTranslateX, sinesTranslateY);
   if(sumButton.state != 0) {sines[sines.length-1].displayLine(7);}
  popMatrix();

   // Record the state of certain sliders.
  previousHue = hueBase;
  previousSat = satBase;
  previousVal = valBase;

  prevHueInc = hueInc;
  prevSatInc = satInc;
  prevValInc = valInc;

  previousNumSine = numSine;
 
  previousBackgroundState = backgroundBang.state;


  //saveFrame("test1-#####.png");


   // Reset hide/show booleans to default values (i.e., true or showing).
   resetHideBooleans();
   turnOnSliderControlButtons();

   if (showHelpImage){
    image(testImage,0,0);
   }

   if(showAllControls == false){
    hideAllControls();
   }

dropCount = dropBang.toggleCount;
raiseCount = raiseBang.toggleCount;

 checkDropRaise();

 prevDropCount = dropCount;
 prevRaiseCount = raiseCount;

setupHelpTextValues();  // I shouldn't need to call this function here (should only need in setup(), but I need to for the "spaceButton" to work correctly...for some reason...
  
if(psCallCount==1){
  checkPreSets();
  psCallCount = 0;  
}


if (record == true){
saveFrameFunction();
}

} // End draw
  
 
// 

class BangButton {

    
    int x, y, w, h;
String offText, onText, label;
String helpText = "";
String helpTitleText = "";

boolean isItOn = true;
boolean flashing = false;
boolean visible = true;

int offColor;
int offTextColor; 

Flash buttonFlash;


    int state = 0;
    int numStates;
    int toggleCount = 0;

    float[] values;
    String[] stateNames;
    int[] backgroundColors;
    int[] textColors;

        int onColor;
        int onTextColor;
        int labelColorBang;





    BangButton(int x_, int y_, int w_, int h_, String label_, int numStates_){
        
            x = x_;
            y = y_;
            w = w_;
            h = h_;
     
           label = label_;
        numStates = numStates_;

        values = new float[numStates];
        stateNames = new String[numStates];
        backgroundColors = new int[numStates];
        textColors = new int[numStates];

         onColor = color(0, 0, 20);
         onTextColor = color(0, 0, 92);
         labelColorBang = color(0, 0, 50);

          offColor = onTextColor;
          offTextColor = onColor; 

          buttonFlash = new Flash(x, y, w, h, 4, 50, 100, 100);

    }


     public void update() {

        // count is reset to zero when the mouseButton is released.
        if (count == 0){
         if (over() == true) {
             if (mousePressed == true) {
     
                 toggle();
                 count++;
             }
         }
     }      
             display(); 
             flashing = false; 
             visible = true;        
     }


    public void toggle(){
        state = (state+1) % numStates;
        toggleCount++;
    }

    public void display() {

     textFont(mainFont);

      if (visible == true){
        noStroke();
        fill(backgroundColors[state]);
        rect (x, y, w, h);
        
        if(flashing==true){
        buttonFlash.display();
        }


        textAlign(CENTER);
        fill(textColors[state]);
        text(stateNames[state], x+PApplet.parseInt(w/2), y+PApplet.parseInt(h*0.75f));
        fill(labelColorBang);
        textAlign(LEFT);
        text(label, x+w+5, y+PApplet.parseInt(h*0.75f));

        if(over() &&  helpBang.state==1){
         drawToolTip();
        }

      }

    }

    // inherit void update() from ToggleButton class.
    
    public void setState(int state_, float value_, String stateName_, int backgroundColor_, int textColor_){
      values[state_] = value_;
      stateNames[state_] = stateName_;
      backgroundColors[state_] = backgroundColor_;
      textColors[state_] = textColor_;

    }

    public void setLabelColor(int labelColor_){
        labelColorBang = labelColor_;
    }

    public float returnValue(){
        return values[state];
    }

  public boolean over() {
     if (mouseX >= x && mouseX <= x + w && mouseY >= y && mouseY <= y + h)
     {
        return true;
     } else {
        return false; 
     }
} // end over()


public void setValue(int s_){
   if (s_ > numStates-1) { state = numStates-1;}
   if (s_ < 0) {state = 0;}

   state = s_;
}



public void flashOn(){
    flashing = true;
}

public void hide(){
    visible = false;
}

public void setHelpText(String helpTitleText_, String helpText_){
    helpTitleText = helpTitleText_;
    helpText = helpText_;
}


public void drawToolTip(){

if (backgroundBang.state==0){
    fill(0,0,80);
} else {
    fill(0,0,40);
}

textFont(helpTitleFont);
textAlign(LEFT, TOP);
text(helpTitleText, helpX + 10, helpY, helpW - 10, helpH);

float titleWidth = textWidth(helpTitleText); 

if (backgroundBang.state==0){
    fill(0,0,0);
} else {
    fill(0,0,100);
}

textFont(helpFont);
textAlign(LEFT, TOP);
textLeading(16);
text(helpText, helpX + titleWidth + 25 ,helpY + 4,helpW - titleWidth - 25 - 10, helpH );

}


}

class RectButton {
	// by Steve Kranz, 2013; based off of Button class by Casey Reas and Ben Fry.

	int x, w;
  float y, h;

  int bHue, bSat, bBright;
  int sineIndex;
	
	boolean activated = false;
  Flash rectButtonFlash;
  boolean flashing = false;
  boolean show = true;

 RectButton(int x_, float y_, int w_, float h_, int bHue_, int bSat_, int bBright_, int sineIndex_)
  {
  	x = x_;
  	y = y_;
  	w = w_;
  	h = h_;
  	
    bHue = bHue_;
    bSat = bSat_;
    bBright = bBright_;

    sineIndex = sineIndex_;

    
       rectButtonFlash = new Flash(x, PApplet.parseInt(y), w, PApplet.parseInt(h), 4, 50, 100,100);

  	

  } // end RectButton constructor.


 public void update()
 {

  if (activated == false)
  {

   if (flashing){
    rectButtonFlash.display();
   }

 	if(over())
 	{
    if (show){
 		 display(35);

     if (mousePressed == true)
     {
      activate();

     }
  }


 	} else {
    //display(25);
  } // end update
 	}

    flashing = false;
    show = true;
 } // end update()


 public void display(int alphaVal)
 {
 	noStroke();
 	fill(bHue, bSat, bBright, alphaVal);
 	rect(x, y, w, h);
 } // end display()


public boolean over() 
{
 if (mouseX >= x && mouseX <= x + w && mouseY >= y && mouseY <= y + h)
 {
 	return true;
 } else {
 	return false;
 }
} // end over()

public void activate(){
 isFalling[sineIndex] = true;
       activated = true;
}

public void deactivate(){
  activated = false;
  isFalling[sineIndex] = false;
}

public void flashOn(){
  flashing = true;
}

public void hide(){
  show = false;
}



} // end of RectButton class.
class Flash {
	int x, y, w, h;
	float freq;
	int flashColor;
	//float growth; // How much the flash will scale. a growfth value larger than one will enlargify, a value smaller than one will reducimate.
	int hueF, satF, briF;
	float alphaVal;

	Flash(int x_, int y_, int w_, int h_, float freq_, int hueF_, int satF_, int briF_){
		x = x_;
		y = y_;
		w = w_;
		h = h_;
		freq = freq_;
		hueF = hueF_;
		satF = satF_;
		briF = briF_;

	}


public void display(){

    alphaVal = 50 * cos(frameCount/20.0f * freq) + 50;
   
    noStroke();
    fill(hueF, satF, briF, alphaVal);
	rect(x, y, w, h);
}



}
// The RadioButtons class is basically a set of toggle buttons, and checks to make sure only one is selected.

class RadioButtons {

  int numButtons;
  boolean[] radioChoose;
  boolean[] previousRadioChoose;
  ToggleButton[] radioButtons;
  BangButton tutLabel;
  int labelFore;
  int labelBack;

  
  // Origin of the set of toggle buttons
  int xR, yR;
  int rows, cols;
  int wR, hR;
  int wSpace, hSpace;


  RadioButtons(int xR_, int yR_, int wR_, int hR_, int wSpace_, int hSpace_, int col_, int row_, int numButtons_ ){
  xR = xR_;
  yR = yR_;

  rows = row_;
  cols = col_;
  numButtons = numButtons_;

  wR = wR_;
  hR = hR_;
  wSpace = wSpace_;
  hSpace = hSpace_;

  previousRadioChoose = new boolean[numButtons];
  radioButtons = new ToggleButton[numButtons];

  for (int i = 0; i < numButtons; i++){
  	radioButtons[i] = new ToggleButton(xR + (i % cols ) * (wR + hSpace)  , yR + PApplet.parseInt(i / cols)* (hR + hSpace), wR, hR, str(i+1), str(i+1), " ");  
    radioButtons[i].isItOn = false;
    previousRadioChoose[i] = false;
  }

  tutLabel = new BangButton(xR, yR - 20, wR*3+wSpace*2, 20, "", 1);
  //tutLabel.setState(0,0, "Tutorial", color(0,50,50), color(0,50,100) );

} // End constructor


public void update(){

  if (backgroundBang.state==0){
    labelFore = color(0,0,0);
    labelBack = color(0,0,100);
  } else {
    labelFore = color(0,0,100);
    labelBack = color (0,0,0);
  }

  tutLabel.setState(0,0, "Tutorial", labelBack, labelFore );

   tutLabel.update();

  for (int i = 0; i < numButtons; i++){

    radioButtons[i].update();

    if (previousRadioChoose[i] != radioButtons[i].isItOn && radioButtons[i].isItOn == true){
      for (int j = 0; j < numButtons; j++){
        radioButtons[j].isItOn = false;
      }
      radioButtons[i].isItOn = true;
    }
    
    previousRadioChoose[i] = radioButtons[i].isItOn;
  }
}


public boolean isItActive (int i){
  if(radioButtons[i].isItOn == true){
    return true;
  } else {
    return false;
  }
}

public void turnOn(int i){
  radioButtons[i].isItOn = true;
}

public void turnOff(int i){
  radioButtons[i].isItOn = false;
}

public boolean allOff() {
  int sum = 0;
  for (int i = 0; i < numButtons; i++){
    sum += PApplet.parseInt(radioButtons[i].isItOn);
  }
  if (sum == 0) {return true;}
  else          {return false;}
}

public void turnAllOff(){
  for (int i = 0; i < radioButtons.length; i++){
    radioButtons[i].isItOn = false;
  }
}

} // end class

class Sine {
  float n;
  int c;

  float hueSine, satSine, valSine;





  int N = 800;  // Number of samples or "bins"
  float[] barHeight;
  float[] barBottom; 
  float[] barTop;
  float period;

  float amplitude;
  float dAmp;
  float dPhase;
  float dFreq;

  float currentAmp;
  float currentPhase;
  float currentFreq;


  float baseline;
  float phase;
  



  float[] velocity;
  boolean falling = false;
  

  
  Sine(float n_, float amplitude_, float phase_, float baseline_, float hue_){
   
    n = n_;   // frequency of the sine wave in sin(nx)
    amplitude = amplitude_/2; // amplitude of sine wave in pixels
    phase = phase_; // phase of the sine wave 
    hueSine = hue_; // hueVar of the rectangles
    baseline = baseline_;   // starting y-value of baseline
    
    
    period = 6.283185307f;  // processing.js does not recognize TAU;
        
    velocity = new float[N];
    barTop = new float[N];
    barBottom = new float[N];
    barHeight = new float[N];
     
    falling = false;
    
    for (int i = 0; i < N; i++){
      barHeight[i] = amplitude; 
      barBottom[i] = baseline;
      barTop[i] = barBottom[i] - barHeight[i];
      velocity[i] = 0;
    }
  } // end Sine constructor
  


  public void printVal(){
   for (int i= 0; i < N; i++){
     println(barHeight[i]);
   }
  }
  
  public void update(){
    
    
    for (int i = 0; i < N; i++){
    
       currentPhase = phase + dPhase * frameCount;
       
       // Using sines...
       if (sinesOrCosines==true){
         currentAmp = amplitude  * (sin((PApplet.parseFloat(frameCount) * dAmp)+3.141f/2) + 1)/2 ;
         currentFreq = n * (sin(PApplet.parseFloat(frameCount) * dFreq) +1 )/1;
         barHeight[i] = currentAmp * sin((currentFreq * i * (period/N)) - currentPhase ) + currentAmp;
       }

       // Using cosines...
        else if (sinesOrCosines == false){
         currentAmp = amplitude  * (cos(PApplet.parseFloat(frameCount) * dAmp + 0) + 1)/2 ;
         currentFreq = n * (cos(PApplet.parseFloat(frameCount) * dFreq) +1 )/2;
         barHeight[i] = currentAmp * cos((currentFreq * i * (period/N)) - currentPhase ) + currentAmp;
       }
      barTop[i]    = barBottom[i] - barHeight[i];
    }
    
    
    
  }
  
 public void fall(int i){
  velocity[i] += acceleration;
  barBottom[i] += velocity[i];
 }
 

 public void halt(int i, float value){
   barBottom[i] = value;
  if (stickyBang.state == 1) {velocity[i] = 0;} // Bug or feature? 
 }
      
  public float checkTop(int i){
    return barTop[i];
  }
  
  public float checkBot(int i){
    return barBottom[i];
  }
  
  // Initially the number of samples in a sine was referred to as "bins"
  public int bins(){
    return N;
  }
  


//////////////////////////////////
////////////////////////////////// display functions

  public void displayBoxes(){
    for (int i = 0; i < N; i++){
      noStroke();
      fill(hueSine, satSine, valSine, 100);
      rect(PApplet.parseInt(i*(widthSine/N)), ceil(barBottom[i]), PApplet.parseInt(widthSine/N), floor(-barHeight[i]));
    }
  }

  public void displayBoxStroke(){
   
    float strokeVal;

    if (backgroundBang.state==0){
      strokeVal = 0;
    } else {
      strokeVal = 100;
    }

    for (int i = 0; i < N; i++){ 
      noFill();
      strokeWeight(1);
      stroke(0, 0, strokeVal, 25);
      rect(PApplet.parseInt(i*(widthSine/N)), ceil(barBottom[i]), PApplet.parseInt(widthSine/N), floor(-barHeight[i]));
    }
  }
  



  public void displayLine(int weight){
    int lineColor;
    //float lineVal = 0;

    // quick and dirty way of making the Sum line black/white. This assumes that the Sum line is set to be thicker than 6.
    if (weight > 6){
      if (backgroundBang.state==0){
        lineColor = color(0,0,0);
      } else {
        lineColor = color(0,0,100);
      }
    } else {
        lineColor = color(hueSine, satSine, valSine);
    }



    for(int i = 0; i < N-1; i++){
      stroke(lineColor);
      strokeWeight(weight);
      line(i*(widthSine/N)+widthSine/(2*N), barTop[i], (i+1)*(widthSine/N)+widthSine/(2*N), barTop[i+1]);
    }
  }
  //////////////////////////////  end display functions
  ////////////////////////////// 
  
  public void setAmplitude (float amp_) {
    amplitude = amp_/2;
  }

  public void setPhase (float phase_) {
    phase = phase_;
  }

  public void setFreq (float freq_) {
    n = freq_;
  }

  public void setDeltaAmplitude(float dAmp_) {
    dAmp = dAmp_/100;
  }

  public void setDeltaPhase( float dPhase_) {
    dPhase = dPhase_/100;
  }

  public void setDeltaFreq(float dFreq_) {
    dFreq = dFreq_/1000;
  }

  
  public void setBinNum (int bins) {
    N = bins;
  }
  
  public void setHue (float hue_) {
    if (hue_ < 0) {hue_ += 360;}
    hueSine = hue_;
  }

  public void setVal (float val_){
    if (val_ < 0){val_ += 100;}
    valSine = val_;
  }

  public void setSat (float sat_) {
    if (sat_ < 0) {sat_ +=100;}
    satSine = sat_;
  }

  public void raiseToBaseline() {
    for (int i = 0; i < N; i++){
      barBottom[i] = baseline;
    }
  }

 public void setVelocity(float vel_) {
  for (int i=0; i < N; i++){
    velocity[i] = vel_;
  }
 }




} // end of Sine class

// Sinusoid: do you say "sine-uh-soyd," "sine-us-oyd," "sine-ya-soyd," "sine-you-soyd" or "sines and cosines"? 




class ToggleButton {

int x, y, w, h;
String offText, onText, label;
boolean isItOn = true;

int onColor;
int onTextColor;
int offColor;
int offTextColor; 
int labelColor;

Flash toggleFlash;
boolean flashing = false;



 ToggleButton(int x_, int y_, int w_, int h_, String offText_, String onText_, String label_) {
 	x = x_;
 	y = y_;
 	w = w_;
 	h = h_;
   offText = offText_;
   onText = onText_;
   label = label_;

   onColor = color(0, 0, 20);
   onTextColor = color(0, 0, 92);
   offColor = onTextColor;
   offTextColor = onColor; 
   labelColor = color(0, 0, 20);

   toggleFlash = new Flash(x, y, w, h, 4, 50, 100,100);

 }






public void update() {


if (backgroundBang.state==0){
   onColor = color(0,0,20);
   onTextColor = color(0,0,92);
   offTextColor = onColor;
   offColor = onTextColor;
} else {
   onColor = color(0,0,92);
   onTextColor = color(0,0,20);
   offTextColor = onColor;
   offColor = onTextColor; 
}

   
   // count is reset to zero when the mouseButton is released.
   if (count == 0){
	if (over() == true) {
		if (mousePressed == true) {

			toggle();
			count++;
		}
	}
}
   
		display();
      flashing = false;
		
}


public void toggle(){
	isItOn = !isItOn;
}

public void setValue(boolean state) {
	isItOn = state;
}





	



public void display() {

textFont(mainFont); 

 if (isItOn){
   noStroke();
   fill(onColor);
   rect(x, y, w, h);

   if (flashing){
      toggleFlash.display();
   }

   textAlign(CENTER);
   fill(onTextColor);
   text(onText, x+w/2, y+h*(.75f));
   fill(labelColor);
   textAlign(LEFT);
   text(label, x + w + 5, y +h * 0.75f);
   


 } else {
   noStroke();
   fill(offColor);
   rect(x, y, w, h);

   if (flashing){
      toggleFlash.display();
   }

   textAlign(CENTER);
   fill(offTextColor);
   text(offText, x+w/2, y+h*(.75f));
   fill(labelColor);
   textAlign(LEFT);
   text(label, x + w + 5, y +h * 0.75f);
}
}



public boolean over() 
{
 if (mouseX >= x && mouseX <= x + w && mouseY >= y && mouseY <= y + h)
 {
 	return true;
 } else {
 	return false; 
 }
} // end over()


public void flashOn(){
 flashing = true;
}

}
class TutButton  {
	
	int x, y, w, h;
	int numStates, state;
  int[] vertTextOffsetArray;

	int textColor, minorTextColor, backgroundColor, highlightColor;
  int shadowColor;

	String[] mainText;

  boolean clickInstructions = false;
  boolean creditText = false;
  boolean progressNumbers = true;
  boolean boldText = false;
  int creditState = 0;
  //boolean showThisTut = true;

  PFont[] tutFontArray;
  int[] tutLeadingArray;



  TutButton(int x_, int y_, int w_, int h_, int numStates_){ 
  x=x_;
  y=y_;
  w=w_;
  h=h_;

  numStates = numStates_;
  state = 0;

  mainText = new String[numStates];

  tutFontArray = new PFont[numStates];
  tutLeadingArray = new int[numStates];
   vertTextOffsetArray = new int[numStates];

  for (int i =0; i < numStates; i++){
    tutFontArray[i] = tutFont;
    tutLeadingArray[i] = 17;
  }






}


public void display(){

    noStroke();
    if (over()){
    	fill(highlightColor);
    } else {
    	fill(backgroundColor);
    }
    rect(x,y,w,h);

 
   

    textAlign(LEFT);
    //textFont(tutFont);
    textFont(tutFontArray[state]);
    textLeading(tutLeadingArray[state]);

    if (boldText==true && state==0){
      fill(shadowColor);
      //text(mainText[state], x+5, y+4 + vertTextOffsetArray[state], w-4, h+20);
    }
     fill(textColor);
    text(mainText[state], x + 4, y + 4 + vertTextOffsetArray[state], w -4, h + 20);


    if (clickInstructions == true) {
      fill(minorTextColor);
      textAlign(LEFT, BOTTOM);
      textFont(mainFont);
      text("Left click to advance, right click to go back.", x+4, y, w, h);
    }

    if(creditText == true && state == creditState) {
      fill(minorTextColor);
      textAlign(RIGHT, TOP);
      textFont(mainFont);
      text("by Steve Kranz, 2014", x+w-10, y+5);
    }

    if(progressNumbers==true){
    fill(minorTextColor);
    textAlign(RIGHT, BOTTOM);
    textFont(tutNumFont);
    text(str(state+1) + "/" + numStates, x, y, w - 4, h); // make that "state + 1" when released to public....
   }

  }




public void update(){

      // count is reset to zero when the mouseButton is released.
     if (count == 0){
       if (over() == true) {
         if (mousePressed == true && mouseButton == LEFT) {
                 toggleUp();
                 count++;
             }
          if (mousePressed == true && mouseButton == RIGHT){
            toggleDown();
            count++;
          }


         }
     }    

   if (backgroundBang.state == 0){
    textColor = color(0,0,0);
    shadowColor = color(0,0,0);
    minorTextColor = color (0,0, 50);
    backgroundColor = color(0,0,92);
    highlightColor = color(0,0,87);
  } else {
    textColor = color(0,0,100);
    shadowColor = color(0,0,0);
    minorTextColor = color(0,0,70);
    backgroundColor = color(0,0,20);
    highlightColor = color(0,0,30);
  }
 
   if (showTut){
  display();
}

}



  
          



    public void toggleUp(){
        state = (state+1) % numStates; 
        //toggleCount++;
    }

    public void toggleDown(){
         state = (state-1);
         if (state < 0){
          state = numStates -1;
         }
    }

public void setState(int i, String pageText){
  mainText[i] = pageText;
}

public void setFont(PFont font_, int leading_, int vertTextOffset_, int i){
  tutFontArray[i] = font_;
  tutLeadingArray[i] = leading_;
  vertTextOffsetArray[i] = vertTextOffset_;
}


public boolean over() 
{
 if (mouseX >= x && mouseX <= x + w && mouseY >= y && mouseY <= y + h)
 {
 	return true;
 } else {
 	return false;
 }
} // end over()


}

public void setupTutorial(int xT, int yT, int wT, int hT, int numLessons) {
     
     //  1. Intro
     //  2. Drop/raise
     //  3. Colors2
     //  4. Bins/sines, drawing options
     //  5. Global sliders + buttons (minus sticky)
     //  6. Functions (square wave, triangle wave, etc)
     //  7. Time FPA
     //  8. Colors3
     //  9. Colors4 
    

    tutorialRadio = new RadioButtons(xT-85, yT+18, 25, 25, 1, 1, 3, 3, 9);

    previousTutButtonStates = new int[numLessons];
    for (int i = 0; i < numLessons; i++){
      previousTutButtonStates[i] = 999; //some number greater than the number of lessons
    }


    tutButtonArray = new TutButton[numLessons];  

    tutButtonArray[0] = new TutButton(xT, yT, wT, hT, 10);
    tutButtonArray[0].setState(0, "Hello! This tutorial will show you how to add sine waves!\n\nTo procede, left-click in this box, or hit the right arrow key.");
    tutButtonArray[0].setState(1, "This is a cosine.");
    tutButtonArray[0].setState(2, "This is also a cosine.");
    tutButtonArray[0].setState(3, "Adjust the amplitude.\n\nIt's the height of the sine.");
    tutButtonArray[0].setState(4, "Adjust the phase. \n\nIt shifts left or right.");
    tutButtonArray[0].setState(5, "Adjust the frequency.\n\nIt's how many peaks there are.");
    tutButtonArray[0].setState(6, "Change the hue. \n\nHue is the color of the rainbow.");
    tutButtonArray[0].setState(7, "Change the saturation. \n\nSaturation is how vibrant the color is.\nZero is grey.");
    tutButtonArray[0].setState(8, "Change the brightness. \n\nBrightness is how light the color is. \nZero is black.");
    tutButtonArray[0].setState(9, "Next: Lesson 2\n\nTo exit: click current number \nTo exit: hit ESCAPE key");
    tutButtonArray[0].clickInstructions = false;

    tutButtonArray[1] = new TutButton(xT, yT, wT, hT, 12);
    tutButtonArray[1].setState(0, "Here's a second cosine wave.\n\nClick to continue.");
    tutButtonArray[1].setState(1, "Adjust the frequency, phase and amplitude independently.");
    tutButtonArray[1].setState(2, "We can add the waves together by having them fall down onto each other. Click on the top wave and it will fall down.");
    tutButtonArray[1].setState(3, "Click on the 'Raise' button to bring the wave up to its original position.\n\nShortcut: \\");
    tutButtonArray[1].setState(4, "Here are more sines. To drop them all simultaneously click on the 'Drop' button.\n\nShortcut: 'return' or 'enter'");
    tutButtonArray[1].setState(5, "Adjust the amplitudes of each. \n\nTry click-dragging down the sliders.");
    tutButtonArray[1].setState(6, "Decrease all amplitudes at the same time with the - button.");
    tutButtonArray[1].setState(7, "Increase all amplitudes at the same time with the + button.");
    tutButtonArray[1].setState(8, "Make the amplitudes randomly walk up or down with the )( button.");
    tutButtonArray[1].setState(9, "Equalize the amplitudes with the () button.\n\nClick multiple times.");
    tutButtonArray[1].setState(10, "These controls also work for the frequencies and phases.");
    tutButtonArray[1].setState(11, "Continue to lesson 3.\n\nLearn how to change the colors!");


    
    tutButtonArray[2] = new TutButton(xT, yT, wT, hT, 9);  
    
    tutButtonArray[2].setState(0, "We change the color of the bottom-most sine with these sliders.\n\nBy default, all the sines are the same color.");
    tutButtonArray[2].setState(1, "Adjust the amount the hue changes per every sine. \n\nRight-click to reset to 0.");
    tutButtonArray[2].setState(2, "Adjust the amonunt the saturation changes per every sine. \n\nIn the positive direction staturation quickly jumps from vibrant to grey.");
    tutButtonArray[2].setState(3, "Adjust the amount the brightness changes per every sine. \n\nIn the positive direction brightness quickly jumps from light to dark.");
    tutButtonArray[2].setState(4, "Adjusting both the change in hue and change in saturation makes some cool patterns.\n\nRight-click each slider to reset to 0.");
    tutButtonArray[2].setState(5, "Adjust saturation and brightness...");
    tutButtonArray[2].setState(6, "Adjust hue and brightness...");
    tutButtonArray[2].setState(7, "Adjust all three...");
    tutButtonArray[2].setState(8, "Click on lesson 4! \n\nLearn how to change how the sines are drawn!");


    tutButtonArray[3] = new TutButton(xT, yT, wT, hT, 8);
    tutButtonArray[3].setState(0, "Adjust the number of bins.\n\nThat's how many samples are in each sine wave." );
    tutButtonArray[3].setState(1, "Adjust the number of sines\n\nNOTE: This resets the frquency, phase and amplitude of each sine.");
    tutButtonArray[3].setState(2, "If both the number of bins and sines is too large, the program may slow down.\n\nCheck the frame rate indicator.\nFPS = frames per second");
    tutButtonArray[3].setState(3, "There are several ways to draw the sines.\n\nThe default is 'fill'.");
    tutButtonArray[3].setState(4, "'Stroke' draws a box around each sample in each sine.\n\nWARNING: This can slow down the program if the number of bins/sines is too high.");
    tutButtonArray[3].setState(5, "'Lines' connects the tops of the samples in each sine.\n\nWARNING: This can slow down the program if the number of bins/sines is too high.");
    tutButtonArray[3].setState(6, "'Sum' draws a line on the top-most sine.\n\nWhen all the sines are fallen it represents the sum of sines.");
    tutButtonArray[3].setState(7, "Continue on to lesson 5!\n\nTo exit: click current number.\nTo exit: hit '~' or '0'.");


    tutButtonArray[4] = new TutButton(xT, yT, wT, hT, 9);
    tutButtonArray[4].setState(0, "The Global sliders multiply the freqeuncy, phase and amplitude of all the sines by the same factor.");
    tutButtonArray[4].setState(1, "Increase the amplitude of all sines  using the global amplitude slider.\n\nRight-click or hit 'E' to reset to 1.");
    tutButtonArray[4].setState(2, "Shift all of the sines to the left or right using the global phase slider.\n\nRight-click or hit 'W' to reset to 0.");
    tutButtonArray[4].setState(3, "Increase or decrease the frequency of all sines by the same factor.\n\nRight-click or hit 'Q' to reset to 1.");
    tutButtonArray[4].setState(4, "High gravity drops the sines quickly... ");
    tutButtonArray[4].setState(5, "...while low gravity drops the sines slowly.");
    tutButtonArray[4].setState(6, "When 'Help' is on, hover over a button or slider for a brief explanation.");
    tutButtonArray[4].setState(7, "Turn the lights off for a darker view.");
    tutButtonArray[4].setState(8, "Hit '6' to continue to lesson 6!\n\nTo exit: click current lesson number.");


    tutButtonArray[5] = new TutButton(xT, yT, wT, hT, 7);
    tutButtonArray[5].setState(0, "We can adjust the amplitudes and phases of the sines to get some cool looking functions");
    tutButtonArray[5].setState(1, "This shape is called a sinc.\n\nIt peaks in the middle and oscillates smaller and smaller as it moves outward.");
    tutButtonArray[5].setState(2, "This is a square wave.\n\nThe global frequency is set to 4 so you see 4 periods.");
    tutButtonArray[5].setState(3, "This is a triangle wave.");
    tutButtonArray[5].setState(4, "This is a wave made of semi-circles.");
    tutButtonArray[5].setState(5, "This is a wave made of simi-circles curving upwards.");
    tutButtonArray[5].setState(6, "Click '7' to continue to lesson 7!\n\nTo exit: click on current lesson number.");

    tutButtonArray[6] = new TutButton(xT, yT, wT, hT, 13);
    tutButtonArray[6].setState(0, "We can adjust the sines in space.\n\nAnd also... in time.");
    tutButtonArray[6].setState(1, "Adjust \u2206 Amp to make the sines' amplitude oscillate in magnitude.");
    tutButtonArray[6].setState(2, "If 10, the amplitude will oscillate quickly.\nIf 2, slowly.\n0, not at all. ");
    tutButtonArray[6].setState(3, "The sines' amplitudes oscillate between zero and it's spatial value.");
    tutButtonArray[6].setState(4, "Right-click each slider to reset it to 0.\n\nOr hit 'H' on the keyboard to reset all \u2206 Amp sliders to zero.");
    tutButtonArray[6].setState(5, "\u2206 Phase changes the phase in time.\n\nThe sine will slide continuosly to the left or the right.");
    tutButtonArray[6].setState(6, "Right-click each \u2206 Phase slider to reset it to 0.\n\nOr hit 'G' to reset all \u2206 Phase sliders to zero");
    tutButtonArray[6].setState(7, "\u2206 Freq changes the frequency in time.\n\nThe frequency of the sine will oscillate between 0 and the spatial value of that sine's frequency");
    tutButtonArray[6].setState(8, "Right-click each \u2206 Freq slider to reset it to 0.\n\nOr hit 'F' to reset all \u2206 Freq sliders to zero.");
    tutButtonArray[6].setState(9, "Let's see how these parameters change in combination...");
    tutButtonArray[6].setState(10, "...kinda looks like the ocean.");
    tutButtonArray[6].setState(11, "Turn 'Sticky' off for an interesting visual.\n\nTurn 'Gravity' to low to enhance the effect.");
    tutButtonArray[6].setState(12, "Continue to lesson 8!");
    // this continues....


    tutButtonArray[7] = new TutButton(xT, yT, wT, hT, 9);
    tutButtonArray[7].setState(0, "We learned in Lesson 3 how to change the colors on the sines.\n\nBut we can also change the colors of the sines...in time!");
    tutButtonArray[7].setState(1, "The '\u2206H' slider adjusts how fast the hue changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[7].setState(2, "If the hue is changing spatially and in time...");
    tutButtonArray[7].setState(3, "The '\u2206S' slider adjusts how fast the saturation changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[7].setState(4, "The staturation changing in both space and time...");
    tutButtonArray[7].setState(5, "The '\u2206B' slider adjusts how fast the brightness changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[7].setState(6, "The brighness changing in both space and time...");
    tutButtonArray[7].setState(7, "We can change all three at once...");
    tutButtonArray[7].setState(8, "Continue to lesson 9!");
    // continues....


    tutButtonArray[8] = new TutButton(xT, yT, wT, hT, 8);
    tutButtonArray[8].setState(0, "Ok... so those colors are pretty crazy, right?\n\nWell... they get crazier.");
    tutButtonArray[8].setState(1, "The '\u2206dH' slider adjusts how fast the change-in-hue (dH) changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[8].setState(2, "The '\u2206dS' slider adjusts how fast the change-in-saturation (dS) changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[8].setState(3, "The '\u2206dB' slider adjusts how fast the change-in-brightness (dB) changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[8].setState(4, "All three at once is pretty crazy...");
    tutButtonArray[8].setState(5, "...and combined with other color sliders can be truly nuts.");
    tutButtonArray[8].setState(6, "Remember the sines can move too!");
    tutButtonArray[8].setState(7, "You've seen all the controls in \nSum Some Sines. Go play and have fun!\n\nHit '0' to exit.");





    



    





/*
    for (int i=6; i < numLessons; i++){
      tutButtonArray[i] = new TutButton(xT, yT, wT, hT, 1);
    }

    */

    tutButtonArray[9] = new TutButton(xT,yT,wT,hT, 3);
    tutButtonArray[9].setState(0, "sum\nsome\nsines");
    tutButtonArray[9].setState(1, "This program was inspired by Albert Michelson's Harmonic Analyzer: a 19th century machine that adds together sine waves using gears, springs and levers.");
    tutButtonArray[9].setState(2, "To learn more check out 'Engineer Guy' on YouTube or www.engineerguy.com.");
    tutButtonArray[9].setFont(titleFont, 30, -13, 0);
    tutButtonArray[9].creditText = true;
    tutButtonArray[9].progressNumbers = false;
    tutButtonArray[9].boldText = true;
  
} // end setupTutorial ????

public boolean oneTimeEvent(int a, int b){
  boolean result;
  result = previousTutButtonStates[a] != b && tutButtonArray[a].state ==b;
  return result;
}

public boolean tutState(int a, int b){
  boolean result;
  result = tutButtonArray[a].state == b;
  return result;
}
 
public void resetTutorial(){
  for (int i = 0; i < tutorialRadio.numButtons; i++){
  if(tutorialRadio.radioButtons[i].isItOn == false){
    tutButtonArray[i].state = 0;
    previousTutButtonStates[i] = 998;
  }
}
}
// This is where actions, flashes and etc. take place. 
public void updateTutorial(){





//          ////
//       ///////
//    //////////
//          ////
//          ////
//          ////
//          ////
//          ////
//          ////
//          ////
//          ////
//          ////     

   // Lesson 1 ---------------------------------
   if(tutorialRadio.isItActive(0)){
    tutButtonArray[0].update();

      hideFrameBox();
      hideGlobalSliders();
      hideButtons();
      hideButtons2();
      hideColor2();
      hideColor3();
      hideColor4();
      hideTime();
      hideBinsBox();
      hideNumBox();
      hideSpaceButtons();
      hideSpaceLabel();
      helpBang.state = 0;
      backgroundBang.state = 0;



    
    if(tutButtonArray[0].state==0){
      //hideTut();
    //  hideSines();
      showSines = false; // this does't do anything...
     // println(showSines);
      //hideTutButtons();
      hideColor1();
      hideSpace();
      setColor1(120, 50, 53);
      setColor3(0,0,0);
      setColor4(0,0,0);
      binSlider.setValue(8);
      numSlider.setValue(0);
      setSLSF(0,0,0,1);

       if (oneTimeEvent(0,0)){
        setGlobal(1,0,0);
        updateGlobalBox();
      }






    } else if (tutButtonArray[0].state==1) {
      //hideTutButtons();
      hideColor1();
      hideSpace();

      lineButton.state = 1;
      sumButton.state = 0;
      strokeButton.state = 0;
      boxesButton.state = 0;

      freqSliderControl.sliders[0].setValue(1);



    } else if (tutButtonArray[0].state==2){
      //hideTutButtons();
      hideColor1();
      hideSpace();

      sumButton.state = 0;
      lineButton.state = 0;
      strokeButton.state = 0;
      boxesButton.state = 1;
      // equivalent to: setSLSF(0,0,0,1);


    } else if (tutButtonArray[0].state==3){  //adjust amplitude
      //hideTutButtons();
      hideColor1();

      setSLSF(0,0,0,1); // sum, line, stroke, fill;
      hideFreq();
      hidePhase();
      ampSliderControl.sliders[0].flashOn();

    } else if (tutButtonArray[0].state==4){
      //hideTutButtons();
      hideColor1();
      setSLSF(0,0,0,1); // sum, line, stroke, fill;
      hideFreq();
      phaseSliderControl.sliders[0].flashOn();
    
    } else if (tutButtonArray[0].state==5){  //adjust frequency
      //hideTutButtons();
      hideColor1();
      setSLSF(0,0,0,1); // sum, line, stroke, fill;
      freqSliderControl.sliders[0].flashOn();

    } else if (tutButtonArray[0].state==6){
      //hideTutButtons();
      setSLSF(0,0,0,1);
      hueSlider.flashOn();
      satSlider.hide();
      brightSlider.hide();
      satBang.hide();
      valBang.hide(); // inconsistent variable name...

      
    } else if (tutButtonArray[0].state==7){
      //hideTutButtons();
      setSLSF(0,0,0,1);
      //satSlider.hide();
      satSlider.flashOn();
      brightSlider.hide();
      //satBang.hide();
      valBang.hide();
    
     } else if (tutButtonArray[0].state==8){
      //hideTutButtons();
      setSLSF(0,0,0,1);
      brightSlider.flashOn();
    
    } else if (tutButtonArray[0].state==9){
      //hideTutButtons();
      setSLSF(0,0,0,1);
      tutorialRadio.radioButtons[1].flashOn();
    }



         previousTutButtonStates[0] = tutButtonArray[0].state;
   }

 

 //               22222222222222222
 //               222222222222222222
 //                              2222
 //                              2222
 //                           22222
 //                         2222
//                        2222
 //                     2222
 //                   2222
 //                 2222
 //                 222222222222222222
 //                 222222222222222222


//2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2  2 2 2 2 2 2 2  (index 1)
/////////////////////////////////////////////////////////
 // Lesson 2 ------------------------------------
  if (tutorialRadio.isItActive(1) ) {
        tutButtonArray[1].update();

      hideFrameBox();
      


      hideGlobalSliders();
      hideButtons();
     // hideButtons2();
      //hideColor2();
      hideColor1();
      hideColor2();
      hideColor3();
      hideColor4();
      hideTime();
      hideBinsBox();
      hideNumBox();
      //hideSpaceButtons();
      hideSpaceLabel();
      helpBang.state = 0;

      



        if (tutButtonArray[1].state ==0){
          numSlider.setValue(1);
          binSlider.setValue(7);
         // setupSines();

          setColor1(225, 50, 80);
          setColor2(30,-20,10);
          setColor3(0,0,0);
          setColor4(0,0,0);
          
          //hueIncSlider.setValue(0);
          //satIncSlider.setValue(0);
          //valIncSlider.setValue(0);
          //dropButtons[1].deactivate();

          //setColor1(40,50,50);
          setSLSF(0,0,0,1);
          dropBang.hide();
          raiseBang.hide();
          hideColor1();
          //hideColor2();
          hideSpaceButtons();
          hideSpace();

          //dropButtons[1].deactivate();
          //dropButtons[1].hide();
          if (oneTimeEvent(1,0)){
                  setGlobal(1,0,0);
                  updateGlobalBox();
          }


          }



           else if(tutButtonArray[1].state==1) {

             //         setColor1(225, 50, 80);

                  phaseSliderControl.sliders[1].flashOn();
                  ampSliderControl.sliders[1].flashOn();
                  freqSliderControl.sliders[1].flashOn();
                  dropBang.hide();
                  raiseBang.hide();
          hideColor1();
          hideColor2();   
          dropButtons[1].hide();
          hideSpaceButtons();
          //hideSpace();
             
          }

          else if (tutButtonArray[1].state==2){
            numSlider.setValue(1);
            //println(numSlider.getValue());
           // println(dropButtons.length);
            dropButtons[1].flashOn();
            dropBang.hide();
            raiseBang.hide();
          hideColor1();
          hideColor2();
          hideSpaceButtons();


          if(oneTimeEvent(1,2)){
            sines[1].raiseToBaseline();
            sines[1].setVelocity(0);
            dropButtons[1].deactivate();
          }
        }


          else if(tutButtonArray[1].state==3){
            numSlider.setValue(1);
            dropBang.hide();
          hideColor1();
          hideColor2();
          hideSpaceButtons();


          raiseBang.flashOn();

            // use this conditional for events that should only occur once (i.e., not persistant changes in state)
            if(previousTutButtonStates[1] != 3 && tutButtonArray[1].state ==3){
                        dropButtons[1].activate();
  
            }
          }

          else if(tutButtonArray[1].state==4){
               numSlider.setValue(6);
               hideColor1();
               dropBang.flashOn();
          hideColor2();
          hideSpaceButtons();
          hideSpace();
          setColor2(30,0,0);


          }

          else if (tutButtonArray[1].state==5){
             hidePhase();
             hideFreq();
             hideSpaceButtons();
             for (int i = 0; i < numSine; i++){
              ampSliderControl.sliders[i].flashOn();
             }

          }

          else if (tutButtonArray[1].state==6){
            hidePhase();
            hideFreq();
            phaseSliderControl.buttonsOff();
            freqSliderControl.buttonsOff();
            ampSliderControl.plus.hide();
            ampSliderControl.explode.hide();
            ampSliderControl.collapse.hide();

            ampSliderControl.minus.flashOn(); 
          }

          else if(tutButtonArray[1].state==7){
            hidePhase();
            hideFreq();
            ampSliderControl.explode.hide();
            ampSliderControl.collapse.hide();

            ampSliderControl.plus.flashOn();
          }

          else if(tutButtonArray[1].state==8){
            hidePhase();
            hideFreq();
            ampSliderControl.collapse.hide();
            ampSliderControl.explode.flashOn();
          }

          else if(tutButtonArray[1].state==9){
            hidePhase();
            hideFreq();
            ampSliderControl.collapse.flashOn();

          } 

          else if (tutButtonArray[1].state==10){
            phaseSliderControl.plus.flashOn();
            phaseSliderControl.minus.flashOn();
            phaseSliderControl.collapse.flashOn();
            phaseSliderControl.explode.flashOn();

            freqSliderControl.plus.flashOn();
            freqSliderControl.minus.flashOn();
            freqSliderControl.collapse.flashOn();
            freqSliderControl.explode.flashOn();


          } 

          else if(tutButtonArray[1].state==11){
                  tutorialRadio.radioButtons[2].flashOn();
          }


     previousTutButtonStates[1] = tutButtonArray[1].state; // needed for oneTimeEvent() to work.
    }




//           33333333333333333
//           333333333333333333
//                          3333
//                          3333
//                          333
//              33333333333333
//              33333333333333
//                          333
//                          3333
//                          3333
//           333333333333333333
//           3333333333333333 


// 33 3 3 3 3 33 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 33  3 3 3 3 3 3 3 3 3 3
// ---------------------------------------------------------------------------

  if (tutorialRadio.isItActive(2) )      { 
           tutButtonArray[2].update();

          numSlider.setValue(11);
          binSlider.setValue(7); 

          setColor3(0,0,0);


      hideFrameBox();
      hideGlobalSliders();
      hideButtons();
     // hideButtons2();
      hideColor3();
      hideColor4();

      hideTime();
      hideSpace();
      hideBinsBox();
      hideNumBox();
      helpBang.state=0;




           
         if (tutButtonArray[2].state==0){
            hideColor2();
            hueSlider.flashOn();
            satSlider.flashOn();
            brightSlider.flashOn(); //  2 lazy 2 fix...
            setColor2(0,0,0);
            setGlobal(1,0,0);

            for (int i =0; i<numSine; i++){
              dropButtons[i].activate();
            }

            if(oneTimeEvent(2,0)){
              setColor1(220,40,75);
              setGlobal(1,0,0);
              updateGlobalBox();
      

            }
          }

          else if (tutButtonArray[2].state==1){
             hueIncSlider.flashOn();

             satSlider.setValue(40);
             brightSlider.setValue(75);

             satIncSlider.setValue(0);
             valIncSlider.setValue(0);

             satSlider.hide();
             satBang.hide();
             brightSlider.hide();
             valBang.hide();

            satIncBang.hide();
            satIncSlider.hide();
            valIncBang.hide();
            valIncSlider.hide();

            if(oneTimeEvent(2,1)){
             setColor1(220,40,75);
             hueIncSlider.setValue(15);
            }
          } 

          else if (tutButtonArray[2].state==2){
            hueSlider.setValue(220);
            brightSlider.setValue(75);

            hueIncSlider.setValue(0);
            hueIncSlider.hide();
            hueIncBang.hide();
            hueBang.hide();
            hueSlider.hide();
            
            valIncSlider.setValue(0);
            valIncSlider.hide();
            valIncBang.hide();
            brightSlider.hide();
            valBang.hide();
            
            satIncSlider.flashOn();

            if(oneTimeEvent(2,2)){
              setColor1(220,99,75);
              satIncSlider.setValue(-13);
              satSlider.setValue(99);

/*
              for(int i = 0; i<numSine; i++){
                sines[i].raiseToBaseline();
                sines[i].setVelocity(0);
                dropButtons[i].deactivate();
              }
*/
              
               // for(int i = 0; i < numSine; i++){
               //   if(i != 8){
                  //dropButtons[i].activate();
             //   }
             // }



            }
          } 

          else if (tutButtonArray[2].state==3){
            hueIncSlider.setValue(0);
            hueIncSlider.hide();
            hueIncBang.hide();
            hueSlider.hide();
            hueBang.hide();

            satSlider.setValue(40);
            hueSlider.setValue(5);

            satIncSlider.setValue(0);
            satIncSlider.hide();
            satIncBang.hide();
            satSlider.hide();
            satBang.hide();

            valIncSlider.flashOn();

            if(oneTimeEvent(2,3)){
              valIncSlider.setValue(-17);
              brightSlider.setValue(45);
            }


          } else if(tutButtonArray[2].state==4){
            valIncSlider.setValue(0);
            valIncSlider.hide();
            valIncBang.hide();

            hueIncSlider.flashOn();
            satIncSlider.flashOn();

            if(oneTimeEvent(2,4)){
              setColor1(0,50,85);
              setColor2(4, -22, 0);
            }

          }

          else if(tutButtonArray[2].state==5){
            hueIncSlider.setValue(0);
            hueIncSlider.hide();
            hueIncBang.hide();

            satIncSlider.flashOn();
            valIncSlider.flashOn();

            if(oneTimeEvent(2,5)){
              setColor1(0,93,0);
              setColor2(0,-6,6);
            }
          }

          else if(tutButtonArray[2].state==6){
            satIncSlider.setValue(0);
            satIncSlider.hide();
            satIncBang.hide();

            hueIncSlider.flashOn();
            valIncSlider.flashOn();
            
            if(oneTimeEvent(2,6)){
              setColor1(145,50,0);
              setColor2(-9, 0, 41);
            }
          } 

          else if(tutButtonArray[2].state==7){
            hueIncSlider.flashOn();
            valIncSlider.flashOn();
            satIncSlider.flashOn();

            if(oneTimeEvent(2,7)){
              setColor1(166, 59, 0);
              setColor2(18,-31, 6);
            }

          }

          else if (tutButtonArray[2].state==8){
            tutorialRadio.radioButtons[3].flashOn();
          } 

    



            previousTutButtonStates[2] = tutButtonArray[2].state;



         }

//                44444        44444
//                44444        44444
//               44444         44444
//               44444         44444
//              44444          44444
//              44444          44444
//              44444444444444444444
//              44444444444444444444
//                             44444
//                             44444
//                             44444
//                             44444
//                             44444
//                             44444

// 4444444444444444444444444444444444444444444444444444444444444444444444
// ---------------------------------------------------------------------------

  if (tutorialRadio.isItActive(3) )      { 
           tutButtonArray[3].update();

         

      
      hideGlobalSliders();
      hideButtons();
      hideColor1();
      hideColor2();
      hideColor3();
      hideColor4();
      hideTime();
      helpBang.state=0;
      setGlobal(1,0,0);





           
         if (tutButtonArray[3].state==0){

          hideSpace();
          setSLSF(0,0,0,1);
          hideNumBox();
          hideFrameBox();
          binSlider.flashOn();
          setColor1(50,27,99);
          setColor2(25,9,-10);
          setColor3(0,0,0);
          setColor4(0,0,0);

          if(oneTimeEvent(3,0)){
            binSlider.setValue(5);
            numSlider.setValue(5);
            setGlobal(1,0,0);
            updateGlobalBox();
    
          }


         }

         else if (tutButtonArray[3].state==1){
          hideBinsBox();
          hideFrameBox();
          numSlider.flashOn();



         }

         else if (tutState(3,2)){  // replaces tutButtonArray[3].state==2;
          sumButton.hide();
          lineButton.hide();
          strokeButton.hide();
          boxesButton.hide(); // should probably be renamed "fillButton" .... 
          frameRateButton.flashOn();
           hideSpace();

           if(oneTimeEvent(3,2)){
            binSlider.setValue(7);
            numSlider.setValue(13);
           }
         }

         else if (tutState(3,3)){ 
          sumButton.hide();
          lineButton.hide();
          strokeButton.hide();
          boxesButton.flashOn();
           hideSpace();
          

          if(oneTimeEvent(3,3)){
            binSlider.setValue(4);
            numSlider.setValue(5);
            setSLSF(0,0,0,1);
          }
         }

         else if (tutState(3,4)){  
          sumButton.hide();
          lineButton.hide();
          strokeButton.flashOn();
           hideSpace();

           if(oneTimeEvent(3,4)){
              setSLSF(0,0,1,1);
           }
         }

         else if (tutState(3,5)){ 
          sumButton.hide();
          lineButton.flashOn();
           hideSpace();
           
           if(oneTimeEvent(3,5)){
            setSLSF(0,1,0,0);
           }
         }

         else if (tutState(3,6)){  
          sumButton.flashOn();
           hideSpace();
           
           if(oneTimeEvent(3,6)){
            setSLSF(1,0,0,1);
            raiseAction();
            fallAction();

           }
         } 

         else if (tutState(3,7)){
          tutorialRadio.radioButtons[4].flashOn();
          hideSpace();
         }

     previousTutButtonStates[3] = tutButtonArray[3].state; // needed for oneTimeEvent() to work.

       }



 //         5555555555555555555555
 //         5555555555555555555555
 //         5555
 //         5555
 //         5555
 //         5555
 //         55555555555555555
 //         5555555555555555555
 //                        55555
 //                         5555
 //                         5555
 //                         5555
 //                         5555
 //                        55555
 //         5555555555555555555
 //         5555555555555555

  if (tutorialRadio.isItActive(4) )      { 
           tutButtonArray[4].update();

         

      
     // hideButtons();
      setupFrameBoxColors();
      hideFrameBox();
      hideBinsBox();
      hideNumBox();

      hideColor1();
      hideColor2();
      hideColor3();
      hideColor4();
     hideSpace();
      hideTime();
 



      if (tutState(4,0)){
       setBinNum(7,8);  // must call setBinNum() in step before amp/pha/freq adjust??
          setColor1(50,27,99);
          setColor2(25,9,-10);
          setColor3(0,0,0);
          setColor4(0,0,0);
          hideButtons();

          globalGlobalButton.flashOn();

          if(oneTimeEvent(4,0)){
            helpBang.state=0;
            setGlobal(1,0,1);
            setSLSF(0,0,0,1);
          }
      }


      else if (tutState(4,1)){
        hideButtons();
        globalAmp.flashOn();
    

        if (oneTimeEvent(4,1)){
          setGlobal(1,0,0);
          updateGlobalBox();


          dropSines();
         

          for (int i =0; i< numSine; i++){
            freqSliderControl.sliders[i].setValue(i+1);
            phaseSliderControl.sliders[i].setValue(0);
            ampSliderControl.sliders[i].setValue(100.f/(i+1));

           // freqSliderControl.sliders[i].update();
           // phaseSliderControl.sliders[i].update();
           // ampSliderControl.sliders[i].update();


          }
        } 
         

      }

      else if (tutState(4,2)){
        hideButtons();
        globalPhase.flashOn();
      }

      else if (tutState(4,3)){
        hideButtons();
        globalFreq.flashOn();
      }

      else if (tutState(4,4)){
        stickyBang.hide();
        helpBang.hide();
        backgroundBang.hide();



        gravityBang.flashOn();
        if(oneTimeEvent(4,4)){
          gravityBang.state=1;
          raiseSines();
          dropSines();
        }
      }

      else if (tutState(4,5)){
        stickyBang.hide();
        helpBang.hide();
        backgroundBang.hide();

        gravityBang.flashOn();
        if(oneTimeEvent(4,5)){
          gravityBang.state=0;
          raiseSines();
          dropSines();
        }
      }

      else if (tutState(4,6)){
        stickyBang.hide();
        backgroundBang.hide();

        helpBang.flashOn();
        if(oneTimeEvent(4,6)){
          helpBang.state=1;

        }
      }

        else if (tutState(4,7)){
          stickyBang.hide();
          backgroundBang.flashOn();
          if(oneTimeEvent(4,7)){
            backgroundBang.state=1;
          }
        }

        else if (tutState(4,8)){
          stickyBang.hide();
          tutorialRadio.radioButtons[5].flashOn();

        }

      
           previousTutButtonStates[4] = tutButtonArray[4].state;
} // end of 5



//              666666
//           6666666666666
//         6666        666
//         6666
//         6666
//         6666
//         6666666666666
//         6666666666666666
//         6666        6666
//         6666        6666
//         6666        6666
//         6666        6666
//           666666666666
//             6666666
// index 5
  if (tutorialRadio.isItActive(5) )      { 
           tutButtonArray[5].update();

           hideTime();
           setupFrameBoxColors();
           hideFrameBox();
          // updateColorButtons();
           hideColor1();
           hideColor2();
           hideColor3();
           hideColor4();
           hideButtons();
           hideSpaceLabel();
           helpBang.state = 0;
           setSLSF(0,0,0,1);


      if (tutState(5,0)){
                   dropSines();
                   setBinNum(7,12);
                   setColor1(10, 80, 18);
                   setColor2(8,-4,4);
                   setColor3(0,0,0);
                   setColor4(0,0,0);
                              setGlobal(1,0,1);

      } 

      else if (tutState(5,1)){
        if (oneTimeEvent(5,1)){
          setFPA(4); // sets FPA to create a sinc
          setGlobal(1,3.14f,1);
        }

      }

      else if (tutState(5,2)){
        if(oneTimeEvent(5,2)){
          setFPA(0); // sets square wave
          setGlobal(2,0,10);
        }

      }

      else if (tutState(5,3)){
        if(oneTimeEvent(5,3)){
          setFPA(2); // set triangle wave
          setGlobal(4,0,6);
        }
      }

      else if (tutState(5,4)){
        if(oneTimeEvent(5,4)){
          setFPA(5); // set semicircles upward
          setGlobal(3,0,3);
        }
      }

      else if (tutState(5,5)){
        if(oneTimeEvent(5,5)){
          setFPA(1); // set semicircles downward
          setGlobal(3,0,3);

        }
      }

      else if (tutState(5,6)){
        tutorialRadio.radioButtons[6].flashOn();
      }


    previousTutButtonStates[5] = tutButtonArray[5].state;
  } // end of lesson 6



  //           7777777777777777777
  //           7777777777777777777
  //                          7777
  //                         7777
  //                        7777
  //                       7777
  //                      7777
  //                     7777
  //                    7777
  //                   7777
  //                  7777
  //                 7777
  //                7777

    if (tutorialRadio.isItActive(6) )      { 
           tutButtonArray[6].update();

           
           hideColor1();
           hideColor2();
           hideColor3();
           hideColor4();
           setupFrameBoxColors();
           //hideButtons();
           hideFrameBox();
           helpBang.state=0;
           


     hideGlobalSliders();

          // hideGlobalSliders();
           //updateGlobalBox();
         
          hideBinsBox();
          hideNumBox();

   

      if (tutState(6,0)){
        hideButtons();
        spaceButton.flashOn();
        timeButton.flashOn();
        ampSliderControl.buttonsOff();
        phaseSliderControl.buttonsOff();
        freqSliderControl.buttonsOff();
        hideDeltaFreq();
        hideDeltaPhase();
        hideDeltaAmp();
        hideButtons2();

        hideBinsBox();
        hideNumBox();

     //hideGlobalSliders();



          setBinNum(8,2);

          setColor1(5,99,18);
          setColor2(18, -24, 22);
          setColor3(0,0,0);
          setColor4(0,0,0);

          if(oneTimeEvent(6,0)){
            setGlobal(1,0,1);
            updateGlobalBox();
            stickyBang.state =0;
            
          }



      } 

      else if (tutState(6,1)){
        hideButtons();
        hideDeltaFreq();
        hideDeltaPhase();
        hideFreq();
        hidePhase();
        hideBinsBox();
        hideNumBox();
        deltaAmpSliderControl.labelButton.flashOn();
        deltaAmpSliderControl.buttonsOff();
        ampSliderControl.buttonsOff();

      }

      else if (tutState(6,2)){
        hideButtons();
        hideDeltaPhase();
        hideDeltaFreq();
        hideFreq();
        hidePhase();
        hideBinsBox();
        hideNumBox();
        deltaAmpSliderControl.sliders[1].flashOn();
        deltaAmpSliderControl.sliders[2].flashOn();
        deltaAmpSliderControl.buttonsOff();
        ampSliderControl.buttonsOff(); 

        if(oneTimeEvent(6,2)){
          deltaAmpSliderControl.sliders[1].setValue(2);
          deltaAmpSliderControl.sliders[2].setValue(10);
        }
      }


      else if (tutState(6,3)){
        hideButtons();
        hideDeltaFreq();
        hideDeltaPhase();
        hideFreq();
        hidePhase();
        hideBinsBox();
        hideNumBox();
        ampSliderControl.sliders[1].flashOn();
        ampSliderControl.sliders[2].flashOn();
        deltaAmpSliderControl.buttonsOff();
        ampSliderControl.buttonsOff();

        if(oneTimeEvent(6,3)){
          ampSliderControl.sliders[1].setValue(75);
          ampSliderControl.sliders[2].setValue(30);

        }
      }

      else if (tutState(6,4)){
        hideButtons();
        hideDeltaFreq();
        hideDeltaPhase();
        hideFreq();
        hidePhase();
        hideBinsBox();
        hideNumBox();
        deltaAmpSliderControl.sliders[1].flashOn();
        deltaAmpSliderControl.sliders[2].flashOn();
        deltaAmpSliderControl.sliders[0].flashOn();
        deltaAmpSliderControl.buttonsOff();
        ampSliderControl.buttonsOff();

        if(oneTimeEvent(6,4)){
          deltaAmpSliderControl.sliders[0].setValue(5);
          deltaAmpSliderControl.sliders[1].setValue(2);
          deltaAmpSliderControl.sliders[2].setValue(10);
          raiseSines();
          dropSines();
              for(int i=0; i<numSine; i++){
            phaseSliderControl.sliders[i].setValue(0);
            deltaPhaseSliderControl.sliders[i].setValue(0);
          }

        }

      }

      else if (tutState(6,5)){
        hideButtons();
        hideDeltaFreq();
        hideDeltaAmp();
        hideFreq();
        hideAmp();
        hideBinsBox();
        hideNumBox();

        deltaPhaseSliderControl.sliders[1].flashOn();
        deltaPhaseSliderControl.sliders[2].flashOn();
        deltaPhaseSliderControl.buttonsOff();
        phaseSliderControl.buttonsOff();

        if(oneTimeEvent(6,5)){
          raiseSines();
          deltaPhaseSliderControl.sliders[0].setValue(0);
          deltaPhaseSliderControl.sliders[1].setValue(-2);
          deltaPhaseSliderControl.sliders[2].setValue(6);
          for(int i=0; i<numSine; i++){
            ampSliderControl.sliders[i].setValue(100);
            deltaAmpSliderControl.sliders[i].setValue(0);
          }
        }
      }

      else if (tutState(6,6)){
        hideButtons();
        hideDeltaFreq();
        hideDeltaAmp();
        hideFreq();
        hideAmp();
        hideBinsBox();
        hideNumBox();
        deltaPhaseSliderControl.sliders[0].flashOn();
        deltaPhaseSliderControl.sliders[1].flashOn();
        deltaPhaseSliderControl.sliders[2].flashOn();
        deltaPhaseSliderControl.buttonsOff();
        phaseSliderControl.buttonsOff();
        
        if(oneTimeEvent(6,6)){
          deltaPhaseSliderControl.sliders[0].setValue(10);
          deltaPhaseSliderControl.sliders[1].setValue(-2);
          deltaPhaseSliderControl.sliders[2].setValue(6); 
          raiseSines();
          dropSines();

                 for(int i=0; i<numSine; i++){
            freqSliderControl.sliders[i].setValue(i+1);
            deltaFreqSliderControl.sliders[i].setValue(0);
          }
        }
      }

      else if (tutState(6,7)){
        hideButtons();
        hideDeltaAmp();
        hideDeltaPhase();
        hidePhase();
        hideAmp();
        hideBinsBox();
        hideNumBox();
        freqSliderControl.buttonsOff();
        deltaFreqSliderControl.buttonsOff();
        deltaFreqSliderControl.sliders[1].flashOn();
        deltaFreqSliderControl.sliders[2].flashOn(); 
        for(int i=0; i<numSine; i++){
          phaseSliderControl.sliders[i].setValue(0);
          deltaPhaseSliderControl.sliders[i].setValue(0);
        }
        if(oneTimeEvent(6,7)){
          raiseSines();
          deltaFreqSliderControl.sliders[0].setValue(0);
          deltaFreqSliderControl.sliders[1].setValue(2);
          deltaFreqSliderControl.sliders[2].setValue(10);

        }



       }

      else if (tutState(6,8)){
        hideButtons();
        hideDeltaAmp();
        hideDeltaPhase();
        hideAmp();
        hidePhase();
        hideBinsBox();
        hideNumBox();
        freqSliderControl.buttonsOff();
        deltaFreqSliderControl.buttonsOff();

        deltaFreqSliderControl.sliders[0].flashOn();
        deltaFreqSliderControl.sliders[1].flashOn();
        deltaFreqSliderControl.sliders[2].flashOn();

         if(oneTimeEvent(6,8)){
          deltaFreqSliderControl.sliders[0].setValue(5);
          deltaFreqSliderControl.sliders[1].setValue(2);
          deltaFreqSliderControl.sliders[2].setValue(10);
          raiseSines();
          dropSines();
        }

      }

      else if (tutState(6,9)){
        hideButtons();
         setBinNum(7,12);
         hideSpace();
         hideTime();
        if(oneTimeEvent(6,9)){
          setColor1(131,99,18);
          setColor2(6, -14, 13);
          setColor3(0,0,0);
          setColor4(0,0,0);
          raiseSines();


        }
      }

      else if (tutState(6,10)){
        hideButtons();

        //hideDeltaAmp();

        if (oneTimeEvent(6,10)){

          


          setColor1(221,99,18);
          setColor2(-3, -14, 13);
          setColor3(0,0,0);
          setColor4(0,0,0);

          for (int i=0; i<numSine; i++){
            freqSliderControl.sliders[i].setValue(i+1);
            phaseSliderControl.sliders[i].setValue(0);
            ampSliderControl.sliders[i].setValue(10+100/(i+1));

            dfv(i, 2 + 0.5f*random(-1,1));
            dpv(i, 5 + 0.125f*random(-1,1));
            dav(i, 1 + 0.25f *random(-1,1));



          }
          setGlobal(1,0,4);
          updateGlobalBox();


            raiseSines();
            dropSines();
          updateFPAsliders();



        }
      }

      else if (tutState(6,11)){
        helpBang.hide();
        backgroundBang.hide();
        stickyBang.flashOn();
        if(oneTimeEvent(6,11)){
          stickyBang.state = 1;
        }
      }



      else if (tutState(6,12)){
                tutorialRadio.radioButtons[7].flashOn();
                helpBang.hide();
                backgroundBang.hide();

        if (oneTimeEvent(6,12)){
          
        }
      }



    previousTutButtonStates[6] = tutButtonArray[6].state;
  } // end of lesson 7


//               88888888888
//            88888888888888888
//           8888           8888
//           8888           8888
//           8888           8888
//           8888           8888
//             8888      8888
//               8888888888
//             88888888888888
//           8888           8888
//           8888           8888
//           8888           8888
//           8888           8888
//            88888888888888888
//              8888888888888
//
//  index 7

    if (tutorialRadio.isItActive(7) )      { 
           tutButtonArray[7].update();

           hideColor4();

           hideSpace();
           hideTime();
           hideFrameBox();
           hideGlobalSliders();
           hideButtons2();
           hideButtons();
       
           helpBang.state=0;

           hideBinsBox();
           hideNumBox();
           setColor4(0,0,0);

      if (tutState(7,0)){
        /*
        hueSlider.flashOn();
        satSlider.flashOn();
        brightSlider.flashOn();
        hueIncSlider.flashOn();
        satIncSlider.flashOn();
        valIncSlider.flashOn();
        */
        hueTimeSlider.flashOn();
        satTimeSlider.flashOn();
        valTimeSlider.flashOn();


        if(oneTimeEvent(7,0)){
          setBinNum(7,13);
          setColor1(180,50,50);
          setColor2(0,0,0);
          setColor3(0,0,0);
          setColor4(0,0,0);
          setGlobal(1,0,1);
          updateGlobalBox();
          stickyBang.state=0;
        }
      } 

      else if (tutState(7,1)){
        hueTimeSlider.flashOn();
        satTimeSlider.hide();
        satTimeBang.hide();
        valTimeSlider.hide();
        valTimeBang.hide();

        setColor4(0,0,0);
        if(oneTimeEvent(7,1)){
          setBinNum(7,13);
          setColor1(180,50,50);
          setColor2(0,0,0);
          setColor3(25,0,0); 
          dropSines();
         //setColor4(0,0,0);
        }

      }

      else if (tutState(7,2)){
        hueTimeSlider.flashOn();
        hueIncSlider.flashOn();
        satTimeSlider.hide();
        satTimeBang.hide();
        valTimeSlider.hide();
        valTimeBang.hide();


        if (oneTimeEvent(7,2)){
          setColor2(6,0,0);
          setColor3(25,0,0);
        }
      }

      else if (tutState(7,3)){
        satTimeSlider.flashOn();
        hueTimeSlider.hide();
        hueTimeBang.hide();
        valTimeSlider.hide();
        valTimeBang.hide();

        if (oneTimeEvent(7,3)){
          setColor1(180,50,99);
          setColor2(0,0,0);
          setColor3(0,40,0);
        }
      }

      else if (tutState(7,4)){
        satIncSlider.flashOn();
        satTimeSlider.flashOn();

        hueTimeSlider.hide();
        hueTimeBang.hide();
        valTimeSlider.hide();
        valTimeBang.hide();

        if(oneTimeEvent(7,4)){
          setColor2(0,8,0);
          setColor3(0,20,0);
        }
      }

      else if(tutState(7,5)){
        valTimeSlider.flashOn();
        hueTimeSlider.hide();
        hueTimeBang.hide();
        satTimeSlider.hide();
        satTimeBang.hide();

        if(oneTimeEvent(7,5)){
          setColor2(0,0,0);
          setColor3(0,0,20);

        }
      }

      else if (tutState(7,6)){
        valTimeSlider.flashOn();
        valIncSlider.flashOn();
        hueTimeSlider.hide();
        hueTimeBang.hide();
        satTimeSlider.hide();
        satTimeBang.hide();

        if(oneTimeEvent(7,6)){
          setColor2(0,0,10);
          setColor3(0,0,20);
        }
      }


      else if(tutState(7,7)){
        valTimeSlider.flashOn();
        hueTimeSlider.flashOn();
        satTimeSlider.flashOn();
        if(oneTimeEvent(7,7)){
          setColor2(3, 5, -9);
          setColor3(-15, 63, 40);
        }
      }

      else if (tutState(7,8)){
        tutorialRadio.radioButtons[8].flashOn();
      }




    previousTutButtonStates[7] = tutButtonArray[7].state;
  } // end of lesson 8


  //
//           666666666666
//         6666666666666666
//         6666        6666
//         6666        6666
//         6666        6666
//         6666        6666
//           666666666666
//               6666666
//                 6666
//                6666
//               6666
//              6666
//             6666

    if (tutorialRadio.isItActive(8) )      { 
           tutButtonArray[8].update();

        hideGlobalSliders();
        hideBinsBox();
        hideNumBox();
       // hideSpace();
        //hideTime();
        hideButtons();
        hideFrameBox();
        hideButtons2();
        helpBang.state = 0;

        

      if (tutState(8,0)){


        if(oneTimeEvent(8,0)){
          //hideSpaceTime();
          hideSpace();
          hideTime();
          setBinNum(7,13);
          setColor1(180,50,50);
          setColor2(0,0,0);
          setColor3(0,0,0);
          setColor4(0,0,0);

          setGlobal(1,0,1);
          updateGlobalBox();

        }

      }

      else if (tutState(8,1)){
        hideSpace();
        hideTime();
        hueIncTimeSlider.flashOn();
        satIncTimeSlider.hide();
        satIncTimeBang.hide();
        valIncTimeSlider.hide();
        valIncTimeBang.hide();

        if(oneTimeEvent(8,1)){
          setColor1(180,50,80);
          setColor2(0,0,0);
          setColor3(0,0,0);
          setColor4(9,0,0);
          dropSines();
        }

      }

      else if (tutState(8,2)){
        valIncTimeSlider.hide();
        valIncTimeBang.hide();
        hueIncTimeSlider.hide();
        hueIncTimeBang.hide();
        satIncTimeSlider.flashOn();
        hideSpace();
        hideTime();
        if(oneTimeEvent(8,2)){
          setColor2(0,0,0);
          setColor3(0,0,0);
          setColor4(0,9,0);
        }
      }

      else if (tutState(8,3)){
        hueIncTimeSlider.hide();
        hueIncTimeBang.hide();
        satIncTimeSlider.hide();
        satIncTimeBang.hide();
        valIncTimeSlider.flashOn();
        hideSpace();
        hideTime();
        if(oneTimeEvent(8,3)){
          setColor2(0,0,0);
          setColor3(0,0,0);
          setColor4(0,0,9);
        }
      }

      else if (tutState(8,4)){
        hueIncTimeSlider.flashOn();
        satIncTimeSlider.flashOn();
        valIncTimeSlider.flashOn();
        hideSpace();
        hideTime();
        if(oneTimeEvent(8,4)){
          setColor4(-3, 5, 9);
        }
      }

      else if (tutState(8,5)){
        hueTimeSlider.flashOn();
        satTimeSlider.flashOn();
        valTimeSlider.flashOn();
        hideSpace();
        hideTime();
        if(oneTimeEvent(8,5)){
          setColor3(70,-65,50);
        }
      }

      else if (tutState(8,6)){
        if(oneTimeEvent(8,6)){
          for (int i = 0; i < numSine; i++){
            fv(i, i+1);
            pv(i, 0);
            av(i, 100);
            dfv(i, 2+random(-1,1));
            dpv(i, 5+0.25f*random(-1,1));
            dav(i, 8+0.25f+random(-1,1));
          }

        }
      }

      else if (tutState(8,7)){
        tutorialRadio.radioButtons[8].flashOn();
      }
    previousTutButtonStates[8] = tutButtonArray[8].state;
  } // end of lesson 9.

  // If none of the tutorial buttons are selected, display the tenth text-button. This is the "default"
  if(tutorialRadio.allOff() == true) {tutButtonArray[9].update(); }



//println(showTutButtons);
  if (showTutButtons){
   tutorialRadio.update();
 }



}




  public void setProgramColors(){

/// For white background
hueOscBackColor = color(15,51,30);
hueOscTextColor = color(15,70,100);
hueModBackColor = color(15, 10, 95);
hueModTextColor = color(15,52,25);

satOscBackColor = color(45,51,30);
satOscTextColor = color(45,70,100);
satModBackColor = color(45, 10, 95);
satModTextColor = color(45,52,25);

valOscBackColor = color(75, 51,30);
valOscTextColor = color(75,70,100);
valModBackColor = color(75, 10, 95);
valModTextColor = color(75,52,25);

// Colors for butons



b0_color = color(0, 0, 95);
t0_color = color(0, 0, 50);
b1_color = color(0, 0, 30);
t1_color = color(0,0, 100);
//b2_color = color(300,10,30);
//t2_color = color(0,0,100);




if (backgroundBang.state==0){
  sumColor = color(0,0,0);
  } 

if (backgroundBang.state==1){
  sumColor = color(0,0,100);
}



backgroundColor = color(0,0,100);
foregroundColor = color(0,0,0);




}


public void displaySum(){
  sines[sines.length-1].displayLine(9);

}

public void drop(int q) {
  
  if (q == 0){} // don't let the bottom-most sinusoid fall down.
  
  else{
  for (int i = 0; i < sines[q].N; i++){
    if(sines[q].barBottom[i] < sines[q-1].barTop[i]){
      sines[q].fall(i);
    }
    if (sines[q].barBottom[i] > sines[q-1].barTop[i]){
      sines[q].halt(i, sines[q-1].barTop[i]);
    }

  } 
}  
}
 


public void setupFrameBox(int x, int y){
   
   int sW = 30;  // slider width
   int sH = 80;  // slider height
   int lH = 15; // label height
   int xS = sW + 6;  // x-space for sliders
   int xS2 = 170; // x-spacing for second part

  int bX = 80;
  int bY = 19;
  int wB = 30;
  int hB = 18;

  int yGlobal = 16;






/*
  textAlign (CENTER, BOTTOM);
  textFont(mainFontBold);
  fill();
  */

  // simply labels for sliders, no functionality
  binButton = new BangButton(x+xS, y, sW, lH, "",1);
  numButton = new BangButton(x,y, sW, lH, "", 1);

  binSlider = new SliderBar(x+xS, y+lH, sH, sW, 0, binValues.length-1);
  binSlider.setOrientation(2);
  binSlider.setValue(binValues.length-2);
  binSlider.labelsFromArray(binValues);

  numSlider = new SliderBar(x, y+lH, sH, sW, 0, 14);
  numSlider.setOrientation(2);
  numSlider.setValue(4);
  numSlider.labelsFromArray(numSineValues);
  numSlider.backgroundColorDay = color(30, 8, 90);
  numSlider.foregroundColorDay = color(30, 20, 70);
  numSlider.backgroundColorNite = color(30, 25, 30);
  numSlider.foregroundColorNite = color(30, 25, 60);






  sumButton = new BangButton(x+bX, y, wB, hB, "Sum", 2);
  sumButton.state = 0;

  lineButton = new BangButton(x+bX,  y + bY, wB, hB, "Line", 2);
  lineButton.state = 0;

  strokeButton = new BangButton(x+bX,  y + 2*bY , wB, hB, "Stroke", 2);
  strokeButton.state = 0;

  boxesButton = new BangButton(x+bX,  y + 3*bY , wB, hB, "Fill", 2);
  boxesButton.state = 1;

  frameRateButton = new BangButton(x+bX, y + 4*bY, wB, hB, "FPS",1);
 // frameRateButton.setState(0,0, nf(frameRate, 2,1), backgroundColor, foregroundColor);




  globalGlobalButton = new BangButton(x+xS2, y, sW*3+6, yGlobal, "", 1);
  globalHorzRuleButton = new BangButton(x+xS2, y + yGlobal - 2, sW*3+6, 1, "", 1);

  globalAmpButton =   new BangButton(x+xS2+xS*2,    y+ yGlobal, sW, lH, "", 1);
  globalPhaseButton = new BangButton(x+xS2+xS, y+ yGlobal, sW, lH, "", 1);
  globalFreqButton =  new BangButton(x+xS2,    y+yGlobal, sW, lH, "", 1);

  globalAmp = new SliderBar(x+xS2+xS*2, y+lH+yGlobal, sH - yGlobal, sW, 1, 10);
  globalAmp.setOrientation(2);
  globalAmp.setValue(1);
  globalAmp.rightClickResetOn();
  globalAmp.setResetValue(1);

  globalPhase = new SliderBar(x+xS2+xS, y+lH+yGlobal, sH - yGlobal,  sW, -3.14f, 3.14f);
  globalPhase.setOrientation(2);
  globalPhase.setValue(0);
  globalPhase.rightClickResetOn();
  globalPhase.setResetValue(0);

  globalFreq = new SliderBar(x+xS2, y + lH+yGlobal, sH - yGlobal, sW, 0.25f, 4);
  globalFreq.setOrientation(2);
  globalFreq.setValue(1);
  globalFreq.rightClickResetOn();
  globalFreq.setResetValue(1);







}

public void setupFrameBoxColors() {

    if (backgroundBang.state == 0){
   b0_color = color(0, 0, 95);
   t0_color = color(0, 0, 50);
   b1_color = color(0, 0, 30);
   t1_color = color(0,0, 100);
   backgroundColor = color(0,0,100);
   foregroundColor = color(0,0,0);
   labelColor = color (0,0,0);
   horzRuleColor = color(0,0,90);
   ggColor = color(0,0,75);
   dropRaiseColor = color(0,0,90);
}
if (backgroundBang.state == 1 ){
   b0_color = color(0, 0, 30);
   t0_color = color(0, 0, 100);
   b1_color = color(0, 0, 95);
   t1_color = color(0,0, 0);
   backgroundColor = color(0,0,0);
   foregroundColor = color(0,0,100);
   labelColor = color (0,0,100);
   horzRuleColor = color(0,0,40);
   ggColor = color(0,0,55);
   dropRaiseColor = color(0,0,30);

}

    binButton.setState(0,0, "Samp", backgroundColor, foregroundColor);
    numButton.setState(0,0, "Sines", backgroundColor, foregroundColor);

    //tutorialRadio.tutLabel.setState(0,0, "Tutorial", backgroundColor, foregroundColor);

    globalGlobalButton.setState(0,0, "Global", backgroundColor, ggColor);

    globalHorzRuleButton.setState(0,0, "", horzRuleColor, horzRuleColor);

    spaceButton.setState(0,0,"Space", backgroundColor, ggColor);
    timeButton.setState(0,0,"Time", backgroundColor, ggColor);

    spaceHRbutton.setState(0,0,"", horzRuleColor, horzRuleColor);
    timeHRbutton.setState(0,0,"", horzRuleColor, horzRuleColor);

    globalAmpButton.setState(0,0, "Amp", backgroundColor, foregroundColor);
    globalPhaseButton.setState(0,0, "Phas", backgroundColor, foregroundColor);
    globalFreqButton.setState(0,0, "Freq", backgroundColor, foregroundColor);


    sumButton.setState(0,0, "off", b0_color, t0_color);
    sumButton.setState(1,1, "on", b1_color, t1_color);
    sumButton.setLabelColor(labelColor);

    lineButton.setState(0,0, "off", b0_color, t0_color);
    lineButton.setState(1,1, "on", b1_color, t1_color);
    lineButton.setLabelColor(labelColor);

    strokeButton.setState(0,0, "off", b0_color, t0_color);
    strokeButton.setState(1,1, "on", b1_color, t1_color);
    strokeButton.setLabelColor(labelColor);

    boxesButton.setState(0,0, "off", b0_color, t0_color);
    boxesButton.setState(1,1, "on", b1_color, t1_color);
    boxesButton.setLabelColor(labelColor);

    frameRateButton.setState(0,0, nf(frameRate, 2,1), backgroundColor, foregroundColor);
    frameRateButton.setLabelColor(labelColor);

    //zenBang.setState(0,0, "zen", b0_color, t0_color);
    //zenBang.setState(1,1, "nez", b1_color, t1_color);

    //helpBang.setState(0,0, "\u00bf ?", b0_color, t0_color);

    dropBang.setState(0,0, "Drop", dropRaiseColor, t0_color);
   
    raiseBang.setState(0,0,"Raise", dropRaiseColor, t0_color);

    helpBang.setState(0,0, "off", b0_color, t0_color);
    helpBang.setState(1,1, "on", b1_color, t1_color);

  gravityBang.setState(0, 1, "low", b1_color, t1_color);
  gravityBang.setState(1, 10, "high",b0_color, t0_color);
  //gravityBang.setState(2, 100, "high", color(0, 0, 20), color(0, 0, 100));
  //gravityBang.state = 1;

  stickyBang.setState(0, 0, "on", b0_color, t0_color);
  stickyBang.setState(1, 1, "off", b1_color, t1_color);
  //stickyBang.state = 0;

  backgroundBang.setState(0,0, "on", color(0,0,20), color(0,0,100));
  backgroundBang.setState(1,1, "off", color(0,0,95), color(0,0,50));
  //backgroundBang.state = 0;






}


public void updateBinsBox(){
  binButton.update();
  binSlider.update();
}

public void updateNumBox(){
  numButton.update();
  numSlider.update();

}

public void updateFrameBox(){


 setupFrameBoxColors();


 //numButton.update();
 //binButton.update();

 // numSlider.update();  
// binSlider.update();


 frameRateButton.setState(0,0,nf(frameRate, 2,1), backgroundColor, foregroundColor);
 frameRateButton.update();

 sumButton.update();
 boxesButton.update();
 strokeButton.update();
 lineButton.update();


}

public void updateGlobalBox(){
 globalGlobalButton.update();
 globalHorzRuleButton.update();


 globalAmpButton.update();
 globalPhaseButton.update();
 globalFreqButton.update();

tempGlobalFreq = globalFreq.update();
tempGlobalAmp  = globalAmp.update();
tempGlobalPhase = globalPhase.update();

}



public void setupSines(){
  sines = new Sine[numSine];

  isFalling = new boolean[numSine];
  dropButtons = new RectButton[numSine];
 
  baselines = new float[numSine];
  freqs = new float[numSine];
  amps = new float[numSine];
  phases = new float[numSine];

  hues = new float[numSine];
  sats = new float[numSine];
  vals = new float[numSine];
 
  hueBase = PApplet.parseInt(hueSlider.update());
  satBase = PApplet.parseInt(satSlider.update());
  valBase = PApplet.parseInt(brightSlider.update());

  heightSine = height - 180;
  boxHeight = heightSine/(numSine + 1);


  for (int j = 0; j < numSine; j++){
   
   freqs[j] = j+1;
   amps[j] = boxHeight;


   baselines[j] = heightSine -  heightSine/sq(numSine+1) - j * (heightSine/(numSine + 1)) - j* heightSine/sq(numSine+1)  ; 
   isFalling[j] = false;

   sines[j] = new Sine(freqs[j], amps[j], phases[j], baselines[j], hues[j]);
   
   



  //Create and initialize drop Buttons
   dropButtons[j] = new RectButton(sinesTranslateX, baselines[j] - boxHeight + sinesTranslateY , PApplet.parseInt(widthSine), boxHeight+1, 0, 0, 50, j); 


      ampSliderControl = new SliderControl(160, 360, 0, 100, numSine, 100, "Amplitude",1, 100);
      phaseSliderControl = new SliderControl(83, 360, -6.283185307f, 6.283185307f, numSine, 0, "Phase",1,0);
      freqSliderControl = new SliderControl(6, 360, 1, 40, numSine, 10, "Frequency",3,0);

      deltaAmpSliderControl = new SliderControl(PApplet.parseInt(widthSine+sinesTranslateX+160), 360, 0, 10, numSine, 0, "\u2206 Amp",1,0);
      deltaPhaseSliderControl = new SliderControl(PApplet.parseInt(widthSine+sinesTranslateX+83), 360, -10, 10, numSine, 0, "\u2206 Phase",1,0);
      deltaFreqSliderControl = new SliderControl(PApplet.parseInt(widthSine+sinesTranslateX+6), 360, 0, 10, numSine, 0, "\u2206 Freq",1,0);

      for (int i = 0; i < numSine; i++){
        freqSliderControl.sliders[i].setValue(i+1);
      }


 }

  setupHues(hueBase);
  setupSats(satBase);
  setupVals(valBase);


  
}






public void setupButtons(int x, int y) {

  int wB = 30;
  int hB = 20;

  helpBang = new BangButton(x, y +(hB+2)*2, wB, hB, "Help", 2);
  helpBang.state = 1;
  gravityBang = new BangButton(x, y+(hB+2)*1, wB, hB, "Gravity", 2);
  stickyBang = new BangButton(x, y+ (hB+2)*0 , wB, hB, "Sticky", 2);
  backgroundBang = new BangButton(x, y+(hB+2)*3, wB, hB, "Lights", 2);



}// end of setupButtons

public void setupButtons2(int x, int y){
  int wB = 40;
  int hB = 30;

  //zenBang = new BangButton(x, y, wB, hB, "", 2);
  //zenBang.state = 0;
  //helpBang = new BangButton(x, y+hB+2, wB, hB, "", 1);
  //helpBang.state = 0;
  raiseBang = new BangButton(x, y, wB, hB, "", 1);
  dropBang = new BangButton(x, y+(hB+2), wB, hB, "", 1);

}




                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
public void updateButtons() {

 // Buttons acting as labels

 
 gravityBang.update();
 stickyBang.update();
 backgroundBang.update();
 helpBang.update();

}

public void updateButtons2(){

  dropBang.update();
  raiseBang.update();
}

public void updateZen(){
    //zenBang.update();

}






 



//---------------------------------------------------------------------------/
public void setupColorSliders(int x, int y) {
  
  int outSpace = 8;
  int sWidth = 30;
  int inSpace = sWidth+2;
  int sHeight = 75;

  //----- HSV Sliders --------------------------
  hueSlider = new SliderBar(x, y, sHeight, sWidth, 0, 359);
  hueSlider.setOrientation(2);
  hueSlider.setValue(50);
  hueSlider.rightClickResetOn();
  hueSlider.setResetValue(180);

  satSlider = new SliderBar(x+inSpace, y, sHeight, sWidth, 0, 99);
  satSlider.setOrientation(2);
  satSlider.setValue(27);
  satSlider.rightClickResetOn();
  satSlider.setResetValue(50);

  brightSlider = new SliderBar(x+2*inSpace, y, sHeight, sWidth, 0, 99);
  brightSlider.setOrientation(2);
  brightSlider.setValue(99);
  brightSlider.rightClickResetOn();
  brightSlider.setResetValue(50);


  //-----------------  d-HSV  Sliders 
  hueIncSlider = new SliderBar(x+3*inSpace+outSpace, y, sHeight, sWidth, -25, 25);
  hueIncSlider.setOrientation(2);
  hueIncSlider.setValue(25);
  hueIncSlider.rightClickResetOn();
  hueIncSlider.setResetValue(0);

  satIncSlider = new SliderBar(x+4*inSpace+outSpace, y, sHeight, sWidth, -25, 25);
  satIncSlider.setOrientation(2);
  satIncSlider.setValue(9);
  satIncSlider.rightClickResetOn();
  satIncSlider.setResetValue(0);

  valIncSlider = new SliderBar(x+5*inSpace+outSpace, y, sHeight, sWidth, -25, 25);
  valIncSlider.setOrientation(2);
  valIncSlider.setValue(-10);
  valIncSlider.rightClickResetOn();
  valIncSlider.setResetValue(0);


  //----------------- \u2206 - HSV Sliders
  hueTimeSlider = new SliderBar(x+6*inSpace+2*outSpace, y, sHeight, sWidth, -100, 100);
  hueTimeSlider.setOrientation(2);
  hueTimeSlider.setValue(0);
  hueTimeSlider.rightClickResetOn();
  hueTimeSlider.setResetValue(0);

  satTimeSlider = new SliderBar(x+7*inSpace+2*outSpace, y, sHeight, sWidth, -100, 100);
  satTimeSlider.setOrientation(2);
  satTimeSlider.setValue(0);
  satTimeSlider.rightClickResetOn();
  satTimeSlider.setResetValue(0);

  valTimeSlider = new SliderBar(x+8*inSpace+2*outSpace, y, sHeight, sWidth, -100, 100);
  valTimeSlider.setOrientation(2);
  valTimeSlider.setValue(0);
  valTimeSlider.rightClickResetOn();
  valTimeSlider.setResetValue(0);



  //----------------- d - \u2206 - HSV Sliders
  hueIncTimeSlider = new SliderBar(x+9*inSpace+3*outSpace, y, sHeight, sWidth, -10, 10);
  hueIncTimeSlider.setOrientation(2);
  hueIncTimeSlider.setValue(0);
  hueIncTimeSlider.rightClickResetOn();
  hueIncTimeSlider.setResetValue(0);

  satIncTimeSlider = new SliderBar(x+10*inSpace+3*outSpace, y, sHeight, sWidth, -10, 10);
  satIncTimeSlider.setOrientation(2);
  satIncTimeSlider.setValue(0);
  satIncTimeSlider.rightClickResetOn();
  satIncTimeSlider.setResetValue(0);

  valIncTimeSlider = new SliderBar(x+11*inSpace+3*outSpace, y, sHeight, sWidth, -10, 10);
  valIncTimeSlider.setOrientation(2);
  valIncTimeSlider.setValue(0);
  valIncTimeSlider.rightClickResetOn();
  valIncTimeSlider.setResetValue(0);



}
//-------------------------------------- end of setupColorSliders()




public void colorSlidersUpdate() {



 if (showColor1==false){
   hueSlider.hide();
   satSlider.hide();
   brightSlider.hide();
 }

  hueBase = ((hueSlider.update() + (hueTimeBase/10) * frameCount) % 360);
  satBase = ((satSlider.update() + (satTimeBase/50) * frameCount) % 100);
  valBase = ((brightSlider.update() + (valTimeBase/50) * frameCount) % 100);



 if (showColor2==false){
   hueIncSlider.hide();
   satIncSlider.hide();
   valIncSlider.hide();
 }

 float hueIncLimit = hueIncSlider.pValue + 0.1f;
/*
  hueInc =  ((hueIncSlider.update() + (hueIncTimeBase/100) * frameCount) % hueIncLimit) ;
  satInc =  ((satIncSlider.update() + (satIncTimeBase/100) * frameCount) % 26) ;
  valInc =  ((valIncSlider.update() + (valIncTimeBase/100) * frameCount) % 26) ;
*/
  hueInc =  ((hueIncSlider.update() + (hueIncTimeBase/100) * frameCount) % 26) ;
  satInc =  ((satIncSlider.update() + (satIncTimeBase/100) * frameCount) % 26) ;
  valInc =  ((valIncSlider.update() + (valIncTimeBase/100) * frameCount) % 26) ;

if (showColor3==false){
  hueTimeSlider.hide();
  satTimeSlider.hide();
  valTimeSlider.hide();
}

  hueTimeBase = hueTimeSlider.update();
  satTimeBase = satTimeSlider.update();
  valTimeBase = valTimeSlider.update();

 if (showColor4 == false){
  hueIncTimeSlider.hide();
  satIncTimeSlider.hide();
  valIncTimeSlider.hide();
 }

  hueIncTimeBase = hueIncTimeSlider.update();
  satIncTimeBase = satIncTimeSlider.update();
  valIncTimeBase = valIncTimeSlider.update();

  

}



public void setupColorButtons(int x, int y){
 
  int outSpace = 8;
  int bWidth = 30;
  int bHeight = 18;
  int inSpace = bWidth+2;


  /// H S V
  hueBang = new BangButton (x,y-20, bWidth, bHeight, "", 2);
  hueBang.setState(0, 0,"H", hueOscBackColor, hueOscTextColor);
  hueBang.setState(1, 1, "H", hueModBackColor, hueModTextColor);

  satBang = new BangButton (x + inSpace ,y-20, bWidth, bHeight, "", 2);
  satBang.setState(0, 0,"S", satOscBackColor, satOscTextColor);
  satBang.setState(1, 1, "S", satModBackColor, satModTextColor);

  valBang = new BangButton (x+ 2*inSpace ,y-20, bWidth, bHeight, "", 2);
  valBang.setState(0, 0,"B", valOscBackColor, valOscTextColor);
  valBang.setState(1, 1, "B", valModBackColor, valModTextColor);


// dH, dS, dV -----------------------------------------///
  hueIncBang = new BangButton (x+3*inSpace + outSpace,y-20, bWidth, bHeight, "", 2);
  hueIncBang.setState(0, 0,"dH", hueOscBackColor, hueOscTextColor);
  hueIncBang.setState(1, 1, "dH", hueModBackColor, hueModTextColor);

  satIncBang = new BangButton (x +4*inSpace + outSpace, y-20, bWidth, bHeight, "", 2);
  satIncBang.setState(0, 0,"dS", satOscBackColor, satOscTextColor);
  satIncBang.setState(1, 1, "dS", satModBackColor, satModTextColor);

  valIncBang = new BangButton (x+ 5*inSpace+ outSpace, y-20, bWidth, bHeight, "", 2);
  valIncBang.setState(0, 0,"dB", valOscBackColor, valOscTextColor);
  valIncBang.setState(1, 1, "dB", valModBackColor, valModTextColor);



// \u2206H, \u2206S, \u2206B
  hueTimeBang = new BangButton (x+6*inSpace+ 2*outSpace,y-20, bWidth, bHeight, "", 2);
  hueTimeBang.setState(0, 0,"\u2206H", hueOscBackColor, hueOscTextColor);
  hueTimeBang.setState(1, 1, "\u2206H", hueModBackColor, hueModTextColor);

  satTimeBang = new BangButton (x + 7*inSpace+ 2*outSpace ,y-20, bWidth, bHeight, "", 2);
  satTimeBang.setState(0, 0,"\u2206S", satOscBackColor, satOscTextColor);
  satTimeBang.setState(1, 1, "\u2206S", satModBackColor, satModTextColor);

  valTimeBang = new BangButton (x+ 8*inSpace+ 2*outSpace,y-20, bWidth, bHeight, "", 2);
  valTimeBang.setState(0, 0,"\u2206B", valOscBackColor, valOscTextColor);
  valTimeBang.setState(1, 1, "\u2206B", valModBackColor, valModTextColor);


// d\u2206H, d\u2206S, d\u2206B 
  hueIncTimeBang = new BangButton (x+9*inSpace+ 3*outSpace,y-20, bWidth, bHeight, "", 2);
  hueIncTimeBang.setState(0, 0,"\u2206dH", hueOscBackColor, hueOscTextColor);
  hueIncTimeBang.setState(1, 1, "\u2206dH", hueModBackColor, hueModTextColor);

  satIncTimeBang = new BangButton (x + 10*inSpace+ 3*outSpace ,y-20, bWidth, bHeight, "", 2);
  satIncTimeBang.setState(0, 0,"\u2206dS", satOscBackColor, satOscTextColor);
  satIncTimeBang.setState(1, 1, "\u2206dS", satModBackColor, satModTextColor);

  valIncTimeBang = new BangButton (x+ 11*inSpace+ 3*outSpace,y-20, bWidth, bHeight, "", 2);
  valIncTimeBang.setState(0, 0,"\u2206dB", valOscBackColor, valOscTextColor);
  valIncTimeBang.setState(1, 1, "\u2206dB", valModBackColor, valModTextColor);
}

public void updateColorButtons(){

  if (showColor1){
  hueBang.update();
  satBang.update();
  valBang.update();
}

 if (showColor2){
  hueIncBang.update();
  satIncBang.update();
  valIncBang.update();
}

 if (showColor3){
  hueTimeBang.update();
  satTimeBang.update();
  valTimeBang.update();
}

if (showColor4){
  hueIncTimeBang.update();
  satIncTimeBang.update();
  valIncTimeBang.update();
}

}




public void setupHues(float baseHue) {

  for(int i = 0; i < numSine; i++) {
     sines[i].setHue(( (hueBase )  + i* hueInc)%360);
  }
}

public void setupSats(float baseSat){
  for (int i =0; i < numSine; i++){
    sines[i].setSat((baseSat + i *satInc)%100);
  }
}

public void setupVals(float baseVal){
  for(int i = 0; i < numSine; i++){
    sines[i].setVal((baseVal +i *valInc)%100);
  }
}


public boolean numSineChange(){
 if (numSine != previousNumSine) {
 return true;
 } else { 
 return false;
 }
}
    
public boolean hueChange(){
  if (hueBase != previousHue) {
    return true;
    } else {
    return false;
    }
  }

  public boolean satChange(){
    if (satBase != previousSat) {
     return true;
     } else {
     return false;
     }
    }

public boolean valChange(){
  if (valBase != previousVal) {return true;} 
  else                        {return false;}
}

public boolean hueIncChange(){
  if (hueInc != prevHueInc ) {return true;}
  else                       {return false;}
}

public boolean satIncChange(){
  if (satInc != prevSatInc ) {return true;}
  else                       {return false;}
}

public boolean valIncChange(){
  if (valInc != prevValInc ) {return true;}
  else                       {return false;}
}



  public void mouseReleased() {
  count = 0;
}




public void setupSpaceTime(){
   int widthST = 228;
   int heightST = 20;
   int yAdjust = 76;
   int yValue = PApplet.parseInt(baselines[freqSliderControl.numSliderBar-1] - boxHeight/2) + sinesTranslateY - yAdjust;

  spaceButton = new BangButton(6, yValue, widthST, heightST, "", 1);
  spaceHRbutton = new BangButton(6, yValue+heightST -2, widthST, 1, "", 1);  // HR = horizontal rule

  timeButton = new BangButton(PApplet.parseInt(widthSine+sinesTranslateX+6), yValue, widthST, heightST, "", 1);
  timeHRbutton = new BangButton(PApplet.parseInt(widthSine+sinesTranslateX+6), yValue+heightST -2, widthST, 1, "", 1);


}

public void updateSpace(){
  spaceButton.update();
  spaceHRbutton.update();

}

public void updateTime(){
  timeButton.update();
  timeHRbutton.update();

}

 public void raiseAction(){
    for (int j = 0; j < numSine; j++){
    sines[j].raiseToBaseline();
    sines[j].setVelocity(0);  
    dropButtons[j].deactivate();    
    }
 }

 public void fallAction(){
         for (int j = 0; j < numSine; j++){
        dropButtons[j].activate();     
    }
 }

public void keyPressed() {

  if (key == 27 && tutorialRadio.allOff() ==false && showAllControls == true){
        tutorialRadio.turnAllOff();

    key=0;
  }

// escape key = key 27
  if (key == 27 && tutorialRadio.allOff() == true && showAllControls == true){
   //if(key =='i'||key=='I'){
    resetProgram();
    key=0;
  }

  if (key == 27 && showAllControls == false){
    showAllControls = true;
    key = 0;
  }

  if(key == '|' || key == 92){
      raiseAction();
  }

  if(key== ENTER || key == RETURN ) {
     fallAction();    
  }

if(key == 'l' || key == 'L'){
  backgroundBang.toggle();
}

  // Reset Freq values to defaults
  if (key == 'a' || key == 'A') {
    for (int j = 0; j < numSine; j++){
      freqSliderControl.sliders[j].setValue(j+1);

    }
  }


  if (key=='s' || key == 'S') {
    phaseSliderControl.setAllToZero();
  }

  if (key=='d' || key == 'D') {
      for (int j = 0; j < numSine; j++){
      ampSliderControl.sliders[j].setValue(100);

    }

  }


  if (key=='f' || key == 'F') {
    deltaFreqSliderControl.setAllToZero();
  }

  if (key=='g' || key == 'G') {
    deltaPhaseSliderControl.setAllToZero();
  }
    if (key=='h' || key == 'H') {
    deltaAmpSliderControl.setAllToZero();
  }








  if (key=='z' || key == 'Z') {
    freqSliderControl.flipValues();
  }

   if (key=='x' || key == 'X') {
    phaseSliderControl.flipValues();
  }

   if (key=='c' || key == 'C') {
    ampSliderControl.flipValues();
  }

  if (key=='v' || key == 'V') {
    deltaFreqSliderControl.flipValues();
  }

   if (key=='b' || key == 'B') {
    deltaPhaseSliderControl.flipValues();
  }

   if (key=='n' || key == 'N') {
    deltaAmpSliderControl.flipValues();
  }

  if (key == '/' || key == '?' ){
    showHelpImage = !showHelpImage;
  }

  if (key == 'q'  ||  key =='Q'){
    globalFreq.setValue(1);
  }

  if (key == 'w' || key == 'W'){
    globalPhase.setValue(0);
  }

  if (key == 'e' || key == 'E'){
    globalAmp.setValue(1);
  }

  if(key == TAB){
    showAllControls =! showAllControls;
    helpBang.state = 0;
  }

  if(key == '.' || key == '>' || keyCode == RIGHT){
    int tutNum = tutButtonArray.length;
    for (int i = 0; i<tutNum; i++ ){
      tutButtonArray[i].toggleUp();
    }
  }

  if(key == ',' || key == '<' || keyCode == LEFT){
       int tutNum = tutButtonArray.length;
      for (int i = 0; i<tutNum; i++ ){
         tutButtonArray[i].toggleDown();
    }
  }

  if(key=='`' || key == '~' || key == '0' || key == ')' ){
    tutorialRadio.turnAllOff();
  }



  if(key=='1' || key =='!'){
    tutorialRadio.radioButtons[0].isItOn = true;
  }

  if(key=='2' || key =='@'){
    tutorialRadio.radioButtons[1].isItOn = true;
  }

  if(key=='3' || key =='#'){
    tutorialRadio.radioButtons[2].isItOn = true;
  }

  if(key=='4' || key =='$'){
    tutorialRadio.radioButtons[3].isItOn = true;
  }
 

  if(key=='5' || key =='%'){
    tutorialRadio.radioButtons[4].isItOn = true;
  }

  if(key=='6' || key =='^'){
    tutorialRadio.radioButtons[5].isItOn = true;
  }
  if(key=='7' || key =='&'){
    tutorialRadio.radioButtons[6].isItOn = true;
  }

  if(key=='8' || key =='*'){
    tutorialRadio.radioButtons[7].isItOn = true;
  }
 
  if(key=='9'){
    tutorialRadio.radioButtons[8].isItOn = true;
  }

  if(key=='0' || key ==')'){
  }

/*
  if(key == ' '){

    saveFrameFunction();

  } */

  if (key == 'r' || key == 'R'){
    record = !record; // toggle record on/off for saving animation.
  }

  if (key == 'p' || key == 'P'){
    sinesOrCosines = !sinesOrCosines;
  }

  if (key == '{'){
    randomColor12();
  }

  if (key == '['){
    randomColor12small();
  }

  if (key =='}'){
    randomColor34();
  }

  if (key ==']'){
    randomColor34small(20);
  }

  if (key == BACKSPACE || key == DELETE){
    setColor3(0,0,0);
    setColor4(0,0,0);
  }

  if (key == ';' || key==':'){
    randomSpace();
  }

// key 39 = single quote, key 34 = double quote
  if(key ==39 || key == 34 ){
    randomTime();
  }

  if(key == ' '){
   randomRoulette();
  }











  //     ===========================
//     ===========================
//     ===========================
//     ===========================
//     ===========================
//     ===========================
//     ===========================
//     ===========================
//     ===========================
//     ===========================

    if (key =='=' || key =='+'){
   
    //prevPreSetCount = preSetCount;
    preSetCount++;
   // if (preSetCount > 8){preSetCount = 0;}
    preSetCount = preSetCount % 11;

     checkPreSets();
     psCallCount = 1; // each preset is called twice...

  }

/*
  if(key == '_' || key =='-'){
    preSetCount--;
    //if(preSetCount < 0){preSetCount = 8;}
    preSetCount = preSetCount % 9;
    checkPreSets();
    psCallCount = 1;
  }
*/
 
}

/*
void preSetSecondCall(int psVal, int callVal){
if (callVal = 1){
  if (psVal = 0){
    ps0();
  } 
  else if (psVal = 1){
    ps1();
  }
}

} // end preSetSecond call */

public void preSets(int psVal){


 //int preSetCounter = 0; //define in main

}

public void ps0(){
  prevPreSetCount =0;
  setBinNum(7,13);
  setGlobal(1,0,1);
  setSLSF(0,0,0,1);
    stickyBang.state = 0;
  gravityBang.state = 1;

  //numSineChange();
  for (int i = 0; i < numSine; i++){
    fv(i,2);
    pv(i,0);
    av(i,100);
    dfv(i,0);
    dpv(i,0);
    dav(i,0);
  }
  fv(0,35);
  dfv(0,9);

  setColor1(1,1,1);
  setColor2(2,3,4);
  setColor3(83,54,-9);
  setColor4(2,-10,1);
  dropSines();

}

public void ps1(){
  preSetCount=1;
  setBinNum(8,5);
  setSLSF(0,0,0,1);
    stickyBang.state = 0;
  gravityBang.state = 1;
  for(int i = 0; i < numSine; i++){
    av(i, 50);
  }
  setColor1(50,50,50);
  setColor2(5,6,7);
  setColor3(0,0,0);
  setColor4(0,0,0);
  dropSines();
}

public void ps2(){
  setBinNum(3, 13);
  setSLSF(0,0,0,1);
  dropSines();
  setGlobal(1,0,1.5f);
    stickyBang.state = 0;
  gravityBang.state = 1;
  //backgroundBang.state = 1;
  for(int i = 0; i<numSine; i++){
    fv(i,21);
    dpv(i, 7.5f + random(-3,3));
  }
    setColor1(50, 27,99);
    setColor2(25,9,-10);
    setColor3(10,5,-73);
    setColor4(0,0,0);
  
}

public void ps3(){
  setBinNum(8,12);
  setSLSF(0,0,0,1);
  dropSines();
  setGlobal(4,0,3);
  stickyBang.state = 0;
  gravityBang.state = 1;
  for(int i = 0; i<numSine; i++) {
    fv(i, 39+random(-1,1));
    dpv(i, random(-6,6));
    dav(i, 5+random(-2,2));
  }
  setColor1(222,61,62);
  setColor2(5,-15,40);
  setColor3(0,0,0);
  setColor4(0,0,0);
}

public void ps4(){
  setBinNum(7,13);
  setSLSF(0,0,0,1);
  setGlobal(1,0,1);
  dropSines();
  stickyBang.state = 1;
  gravityBang.state = 0;
  for(int i=0; i< numSine; i++){
    fv(i, 5+random(-4,6));
    dfv(i, 9+random(-.125f,.125f));
    dpv(i, 3+random(-.125f, .125f));
  }
  setColor1(50,27,76);
  setColor2(1,13,-5);
  setColor3(1.5f,0,0);
  setColor4(0,0,0);
}

//square wave
public void ps5(){
  stickyBang.state = 0;
  gravityBang.state = 1;
  setSLSF(0,0,0,1);
  setBinNum(8, 12);
  setFPA(0);
  setGlobal(2, 0, 10);
  dropSines();
  setColor1(35, 25, 76);
  setColor2(-4,3,-3);
  setColor3(0,0,0);
  setColor4(0,0,0);

}

public void ps6(){
  stickyBang.state = 0;
  gravityBang.state = 1;
  setSLSF(0,0,0,1);
  dropSines();
  setBinNum(7, 12);
  setFPA(2);
  setGlobal(4,0,6);

    setColor1(35, 25, 76);
  setColor2(-4,3,-3);
  setColor3(0,0,0);
  setColor4(0,0,0);
}

public void ps7(){
  stickyBang.state = 0;
  gravityBang.state = 1;
  setSLSF(0,0,0,1);
  dropSines();
  setBinNum(7, 12);
  setFPA(5);
  setGlobal(3,0,3);
  setColor1(35, 25, 76);
  setColor2(-4,3,-3);
  setColor3(0,0,0);
  setColor4(0,0,0);

  for (int i =0; i < numSine; i++){
    dpv(i, 1);
  }
}

public void ps8(){
    stickyBang.state = 0;
  gravityBang.state = 1;
  setSLSF(0,0,0,1);
  dropSines();
  setBinNum(7, 13);
  setGlobal(1,0,1.5f);
  setColor1(210,25,99);
  setColor2(-5,1,1);
  setColor3(0,0,-40);
  setColor4(0,0,0);
  for (int i = 9; i < 19; i++){
    av(i,5);
  }
}

public void ps9(){
  stickyBang.state = 0;
  gravityBang.state = 1;
  setSLSF(0,0,1,1);
  dropSines();
  setBinNum(4, 8);
  setGlobal(1,0,1);
  setColor1(50,27,99);
  setColor2(25,9,-10);
  setColor3(0,0,0);
  setColor4(0,0,0);
  for (int i = 0; i < numSine; i++){
    dpv(i,4);
  }
}

public void ps10(){
    stickyBang.state = 0;
  gravityBang.state = 1;
  //backgroundBang.state = 0;
  setSLSF(0,0,1,1);
  dropSines();
  setBinNum(2, 13);
  setGlobal(1,0,1);
  setColor1(50,27,99);
  setColor2(25,9,-10);
  setColor3(0,0,0);
  setColor4(0,0,0);
  for (int i = 0; i < numSine; i++){
    dpv(i,random(-2,2));
  }
}

public void checkPreSets(){


  if (preSetCount == 0){
    ps0();
  } else if (preSetCount == 1){
    ps1();
  } else if (preSetCount == 2){
    ps2();
  } else if (preSetCount == 3){
    ps3();
  } else if (preSetCount == 4){
    ps4();
  } else if (preSetCount == 5){
    ps5();
  } else if (preSetCount == 6){
    ps6();
  } else if (preSetCount == 7){
    ps7();
  } else if (preSetCount == 8){
    ps8();
  } else if (preSetCount == 9){
    ps9();
  } else if (preSetCount == 10){
    ps10();
  }
}





//     ===========================
//     ===========================
//     ===========================
//     ===========================

//     ===========================
//     ===========================




/// Discard this?
public void setupSave(){
  int i = numSineValues.length;
  int maxSines = numSineValues[i];

  saveFreq = new float[maxSines];
  savePhase = new float[maxSines];
  saveAmp = new float[maxSines];
  saveDeltaFreq = new float[maxSines];
  saveDeltaPhase = new float[maxSines];
  saveDeltaAmp = new float[maxSines];
  saveDrop = new float[maxSines];


}


public void turnOnSliderControlButtons(){
  freqSliderControl.buttonsOn();
  ampSliderControl.buttonsOn();
  phaseSliderControl.buttonsOn();
  deltaFreqSliderControl.buttonsOn();
  deltaAmpSliderControl.buttonsOn();
  deltaPhaseSliderControl.buttonsOn();

}

public void switchColorButtons(){
  if (backgroundBang.state==1){
    hueBang.state=0;
    hueIncBang.state=0;
    hueTimeBang.state=0;
    hueIncTimeBang.state=0;

    satBang.state=0;
    satIncBang.state=0;
    satTimeBang.state=0;
    satIncTimeBang.state=0;

    valBang.state=0;
    valIncBang.state=0;
    valTimeBang.state=0;
    valIncTimeBang.state=0;
  } else {
    hueBang.state=1;
    hueIncBang.state=1;
    hueTimeBang.state=1;
    hueIncTimeBang.state=1;

    satBang.state=1;
    satIncBang.state=1;
    satTimeBang.state=1;
    satIncTimeBang.state=1;

    valBang.state=1;
    valIncBang.state=1;
    valTimeBang.state=1;
    valIncTimeBang.state=1;
  }
}




public void setFPA(int indexPF){

 //countFPA++;
// indexFPA  = countFPA%numPreFunc;

  for (int i = 0; i< numSine; i++){
    freqSliderControl.sliders[i].setValue(preFunc[i][0][indexPF]);
    phaseSliderControl.sliders[i].setValue(preFunc[i][1][indexPF]);
    ampSliderControl.sliders[i].setValue(preFunc[i][2][indexPF]);
  }


 

}

public void setupPreFunc(){
  int maxNumSines = max(numSineValues);
  
  numPreFunc = 6;
  preFunc = new float [maxNumSines][3][numPreFunc];

  setSquareWave(maxNumSines, 0);
  setSemiCircle(maxNumSines,1);
  setTriangleWave(maxNumSines,2);
  setPeaks(maxNumSines, 3);
  setSinc(maxNumSines, 4);
  setSemiCircleUpwards(maxNumSines, 5);




}

public void setSinc(int num, int pfIndex){
  for (int i = 0; i < num; i++){
    preFunc[i][0][pfIndex] = i+1;
    preFunc[i][1][pfIndex] = 0;
    preFunc[i][2][pfIndex] = 75;
  }
}

public void setSquareWave(int num, int pfIndex){

   for (int i = 0; i < num; i++){
    preFunc[i][0][pfIndex] = i+1;

         preFunc[i][1][pfIndex] = 0;
     if ( (i+1)%4 == 3){
       preFunc[i][1][pfIndex] = 3.141f;
     }

       preFunc[i][2][pfIndex] = 100 * (1/PApplet.parseFloat(i+1));
      if( (i+1)%2 == 0){
       preFunc[i][2][pfIndex] = 0;
      }
  }

}

public void setSemiCircleUpwards(int num, int pfIndex){
    for (int i = 0; i< num; i++){
      preFunc[i][0][pfIndex] = i+1;
      preFunc[i][1][pfIndex] = 3.14f;
      preFunc[i][2][pfIndex] = 100.f/(i+1);
    }
}

public void setSquareWave2(int num, int pfIndex){
 
   for (int i = 0; i < num; i++){
    preFunc[i][0][pfIndex] = 2*i+1;

         preFunc[i][1][pfIndex] = 0;
     if ( (2*i+1)%4 == 3){
       preFunc[i][1][pfIndex] = 3.141f;
     }

       preFunc[i][2][pfIndex] = 100 * (1/PApplet.parseFloat(2*i+1));
      
  }
}

public void setTriangleWave(int num, int pfIndex){
   for(int i = 0; i < num; i++){
    preFunc[i][0][pfIndex] = i+1;
   // preFunc[i][1][pfIndex] = 3.141/2;
   preFunc[i][1][pfIndex] = 0;
    preFunc[i][2][pfIndex] = 100/pow(i+1,2);;
    
    if ((i+1)%2 == 0) {
      preFunc[i][2][pfIndex] = 0;
    } 
    if( (i+1)%4 == 3) {
    //  preFunc[i][1][pfIndex] = -3.141/2;
    }
   }
}

public void setSemiCircle(int num, int pfIndex){
// this is equal to squarewave when the two lines are un-commented

   for (int i = 0; i < num; i++){
    preFunc[i][0][pfIndex] = i+1;

         preFunc[i][1][pfIndex] = 0;
     if ( (i+1)%4 == 3){
      // preFunc[i][1][pfIndex] = 3.141;
     }

       preFunc[i][2][pfIndex] = 100 * (1/PApplet.parseFloat(i+1));
      if( (i+1)%2 == 0){
       //preFunc[i][2][pfIndex] = 0;
      }
  }

}

public void setPeaks(int num, int pfIndex){


   for (int i = 0; i < num; i++){
    preFunc[i][0][pfIndex] = i+1;

         preFunc[i][1][pfIndex] = 0;
     if ( (i+1)%4 == 3){
       preFunc[i][1][pfIndex] = 3.141f;
     }

       preFunc[i][2][pfIndex] = 100 * (1/PApplet.parseFloat(i+1));
      if( (i+1)%2 == 0){
       preFunc[i][2][pfIndex] = 0;
      }
  }

    preFunc[12-1][2][pfIndex] = 25;
    preFunc[36-1][2][pfIndex] = 100/36;






}

// set Sum, line, stroke fill, values must be 1 or 0, else error will throw


public void setSLSF(int sum_, int line_, int stroke_, int fill_){
  sumButton.state = sum_;
  lineButton.state = line_;
  strokeButton.state = stroke_;
  boxesButton.state = fill_;

}

public void setColor1(float h_, float s_, float b_){
 hueSlider.setValue(h_);
 satSlider.setValue(s_);
 brightSlider.setValue(b_);
}

public void setColor2(float h_, float s_, float b_){
  hueIncSlider.setValue(h_);
  satIncSlider.setValue(s_);
  valIncSlider.setValue(b_);
}

public void setColor3(float h_, float s_, float b_){
  hueTimeSlider.setValue(h_);
  satTimeSlider.setValue(s_);
  valTimeSlider.setValue(b_);
}

public void setColor4(float h_, float s_, float b_){
  hueIncTimeSlider.setValue(h_);
  satIncTimeSlider.setValue(s_);
  valIncTimeSlider.setValue(b_);
}

public void setGlobal(float f_, float p_, float a_){
  globalFreq.setValue(f_);
  globalPhase.setValue(p_);
  globalAmp.setValue(a_);
}

public void setBinNum(int b_, int n_){
  binSlider.setValue(b_);
  numSlider.setValue(n_);
}


// Easier way to set FPA and \u2206FPA values, V for value.
public void fv(int i, float value_){
  freqSliderControl.sliders[i].setValue(value_);
}
public void pv(int i, float value_){
  phaseSliderControl.sliders[i].setValue(value_);
}
public void av(int i, float value_){
  ampSliderControl.sliders[i].setValue(value_);
}
public void dfv(int i, float value_){
  deltaFreqSliderControl.sliders[i].setValue(value_);
}
public void dpv(int i, float value_){
  deltaPhaseSliderControl.sliders[i].setValue(value_);
}
public void dav(int i, float value_){
  deltaAmpSliderControl.sliders[i].setValue(value_);
}


public void fvFOR(float[] xxx ){

}

public void updateFPAsliders(){
  for (int i=0; i < numSine; i++){
    freqSliderControl.sliders[i].update();
    phaseSliderControl.sliders[i].update();
    ampSliderControl.sliders[i].update();
    deltaFreqSliderControl.sliders[i].update();
    deltaPhaseSliderControl.sliders[i].update();
    deltaAmpSliderControl.sliders[i].update();

  }
}


public void checkDropRaise(){
  if(prevDropCount != dropCount){
    dropSines();
  }

  if(prevRaiseCount != raiseCount){
   raiseSines();
  }
}

public void dropSines(){
         for (int j = 0; j < numSine; j++){
        dropButtons[j].activate();     
    }
}

public void raiseSines(){
    for (int j = 0; j < numSine; j++){
    sines[j].raiseToBaseline();
    sines[j].setVelocity(0);  
    dropButtons[j].deactivate();    
    }
}

/*
void drawToolTip(String helpText_){
fill(0,0,92);
noStroke();
//rect(helpX, helpY, helpW, helpH);

fill(0,0,0);
textFont(helpFont);
text(helpText_, helpX, helpY, helpW, helpH);

}
*/

// These are the text snippets that are displayed when "Help" is turned on. 
public void setupHelpTextValues(){
  backgroundBang.setHelpText("Lights", "ON = white background, OFF = black background. \nShortcut: L");
  helpBang.setHelpText("Help", "When Help is on, hover over a button or slider to see a brief description.\nHit the ? key to toggle the quick reference." );
  spaceButton.setHelpText("Space", "Space is an illusion. Lunchspace doubly so.");
 timeButton.setHelpText("Time", "Time is big. Really big. You just won't believe how vastly, hugely, mind-bogglingly big it is.\nI mean, you may think it's a long way down the road to the chemist's, but that's just peanuts to time.");

globalAmpButton.setHelpText("Global amplitude", "This slider adjusts the amplitude of all sines simultaneously.\nRight-click or E to reset to 1.");
globalAmp.setHelpText("Global amplitude", "This slider adjusts the amplitude of all sines simultaneously.\nRight-click or E to reset to 1.");
globalPhase.setHelpText("Global phase","Shift all the sines equally left or right.\nRight-click or W to reset to 0.");
globalPhaseButton.setHelpText("Global phase","Shift all the sines equally left or right.\nRight-click or W to reset to 0.");
globalFreq.setHelpText("Global frequency","Multiply the frequency of all sines from 0.25 to 4\nRight-click or Q to reset to 1");
globalFreqButton.setHelpText("Global frequency","Multiply the frequency of all sines from 0.25 to 4\nRight-click or Q to reset to 1");

sumButton.setHelpText("Sum", "Sum displays a thick line on the top-most sine.\nWhen all the sines are dropped ('enter'), this line represetns the sum of the sines.");
lineButton.setHelpText("Line", "Line displays a line connecting the tops of each bin in every sine.\nThis can slow the program down. Disable for best performance.");
strokeButton.setHelpText("Stroke" , "Draws a stroke around each bin in each sine.\nThis can slow the program down. Disable for best performance.");
boxesButton.setHelpText("Fill", "Fill draws a rectangle to represent each bin in each sine.");
frameRateButton.setHelpText("Frame rate", "This is the number of frames the program draws per every second.\n30 FPS is optimal.");

binSlider.setHelpText("Samples","Samples is the number of values in each sine.\nRanges from 8 to 800.");
binButton.setHelpText("Samples","Samples is the number of values in each sine.\nRanges from 8 to 800.");
numSlider.setHelpText("Sines", "This is the number of sine waves that we're adding up.\nRanges from 1 to 40.");
numButton.setHelpText("Sines", "This is the number of sine waves that we're adding up.\nRanges from 1 to 40.");



globalGlobalButton.setHelpText("Global sliders" ,"These global sliders affect all sines equally.\nHit Q, W or E to reset the global frequency, phase or amplitude.");
raiseBang.setHelpText("Raise", "Click this to set all the sines to their original vertical positions.\nShortcut: '\\'' key");
dropBang.setHelpText("Drop", "Click this to make all of the sines fall on top of each other.\nShortcut: ENTER or RETURN");
gravityBang.setHelpText("Gravity","Gravity controls how fast the boxes fall.\nHigh = fast, low = slow.");
stickyBang.setHelpText("Sticky", "When ON, the boxes will 'stick' together. \nWhen OFF, a box's velocity is set to 0 when it contacts a box below it.");

freqSliderControl.labelButton.setHelpText("Frequency","The frequency of a sine is the number peaks in one period.\nA: reset frequencies of all sines.");
phaseSliderControl.labelButton.setHelpText("Phase","Phase shifts a sine to the left or right.\nS: reset phases of all sines to 0.");
ampSliderControl.labelButton.setHelpText("Ampltitude","Amplitude is the height of the sine.\nD: reset amplitudes of all sines to 100.");
deltaFreqSliderControl.labelButton.setHelpText("\u2206 Frequency","Controls the rate at which a sine's frequency oscillates between 0 and its Frequency value.\nF: reset \u2206 Freq of all sines to 0.");
deltaPhaseSliderControl.labelButton.setHelpText("\u2206 Phase", "Controls the rate at which the sine shitfs to the left or the right.\nG: reset \u2206 Phase of all sines to 0.");
deltaAmpSliderControl.labelButton.setHelpText("\u2206 Amplitude", "Controls the rate at which the sine's amplitude oscillates between 0 and its Amplitude value.\nH: reset \u2206 Amp of all sines to 0.");



hueBang.setHelpText("Hue", "Sets the hue value of the bottom-most sine (Sine 1).\nHue is the color of the rainbow: Red to green to blue.");
hueSlider.setHelpText("Hue", "Sets the hue value of the bottom-most sine (Sine 1).\nHue is the color of the rainbow: Red to green to blue.");
satBang.setHelpText("Saturation","Sets the saturation value of the bottom-most sine (Sine 1).\nLow saturation is grey, high saturation is vibrant.");
satSlider.setHelpText("Saturation","Sets the saturation value of the bottom-most sine (Sine 1).\nLow saturation is grey, high saturation is vibrant.");
brightSlider.setHelpText("Brightness","Sets the brightness value of the bottom-most sine (Sine 1). \nLow brightness is dark, high is light.");
valBang.setHelpText("Brightness","Sets the brightness value of the bottom-most sine (Sine 1). \nLow brightness is dark, high is light.");

hueIncSlider.setHelpText("Hue step", "Sets how much the hue-value of a sine increments relative to the sine below it.\nRight-click to reset to 0.");
satIncSlider.setHelpText("Saturation step", "Sets how much the saturation-value of a sine steps relative to the sine below it.\nRight-click to reset to 0.");
valIncSlider.setHelpText("Brightness step", "Sets how the brightness-value of a sine increments relative to the sine below it.\nRight-click to reset to 0.");
  
hueTimeSlider.setHelpText("Hue time", "Sets how fast the hue of Sine 1 changes over time.\nRight-click to reset to 0.");
satTimeSlider.setHelpText("Saturation time","Sets how fast the saturation of Sine 1 changes over time.\nRigh-click to reset to 0.");
valTimeSlider.setHelpText("Brightness time","Sets how fast the brightness of Sine 1 changes over time.\nRigh-click to reset to 0.");

hueIncTimeSlider.setHelpText("Hue step, time", "Changes the hue step in time.\nRight-click to reset to 0.");
satIncTimeSlider.setHelpText("Saturation step, time","Changes the saturation step in time.\nRigh-click to reset to 0.");
valIncTimeSlider.setHelpText("Brightness step, time","Changes the brightness step in time.\nRigh-click to reset to 0.");





for(int i = 0; i < numSine; i++){
  freqSliderControl.sliders[i].setHelpText("Frequency "+ str(i+1),"This sets the frequency of Sine " + str(i+1) +".\nRight-click to reset to " + str(i+1) + "." );
  phaseSliderControl.sliders[i]. setHelpText("Phase "+ str(i+1), "This sets the phases of Sine " +str(i+1)+ ".\nRight-click to reset to 0.");
  ampSliderControl.sliders[i].setHelpText("Amplitude "+str(i+1), "This sets the amplitude of Sine " + str(i+1)+".\nRight-click to reset to 100.");
  
  deltaFreqSliderControl.sliders[i].setHelpText("\u2206 Frequency "+ str(i+1),"This sets the frequency-oscillation rate of Sine " + str(i+1)+  ".\nRight-click to reset to 0." );
  deltaPhaseSliderControl.sliders[i]. setHelpText("\u2206 Phase "+ str(i+1), "This sets phase-shift rate of Sine " +str(i+1)+ ".\nRight-click to reset to 0.");
  deltaAmpSliderControl.sliders[i].setHelpText("\u2206 Amplitude "+str(i+1), "This sets the amplitude-oscillation rate of Sine " + str(i+1)+".\nRight-click to reset to 0.");
}

}

public void drawHelpBackground(){
if(helpBang.state==1){
  if (backgroundBang.state==0){
    fill(0,0,92);
  } else {
    fill(0,0,10);
  }
  
  noStroke();
  rect(helpX, helpY, helpW, helpH);
}
}



// if all the drawing options are turned off, indicate that the "fill" button should be activated
public void drawingWarning(){
  if(sumButton.state==0 && lineButton.state==0 && strokeButton.state==0 && boxesButton.state==0){
    boxesButton.flashOn();
  }
}

public void saveFrameFunction(){
    String timestamp = year() +"-" +nf(month(),2) +"-"+ nf(day(),2) + "_"  + nf(hour(),2) +"."+ nf(minute(),2) +"."+ nf(second(),2);

  //  Save the entire screen:
  //  saveFrame("/screens/EXPORTS_sss/"+timestamp+"-#####.png");

  //  Save just the sines sections of the screen:
   PImage img = get(240, 160, 800, 560);
   img.save ("/screens/EXPORTS_sss/"+timestamp+"_"+nf(frameCount, 4)+"_get.png");

}

public void randomColor12(){
  setColor1(random(360), random(100), random(100));
  setColor2(random(-25, 25), random(-25, 25), random(-25,25));
}

public void randomColor12small(){
  setColor1(random(360), random(100), random(100));
  setColor2(random(-5, 5), random(-5, 5), random(-5,5));
}


public void randomColor34(){
  setColor3(random(-100, 100), random(-100, 100), random(-100, 100));
 // setColor4(random(-10, 10), random(-10, 10), random(-10, 10));
}

public void randomColor34small(int v){
  setColor3(random(-v, v), random(-v, v), random(-v, v));
 // setColor4(random(-2, 2), random(-2, 2),random(-2, 2));
}

public void resetProgram(){
  setBinNum(7,4);
  setColor1(50,27,99);
  setColor2(25,9,-10);
  setColor3(0,0,0);
  setColor4(0,0,0);

  showAllControls = true;

  raiseSines();

  stickyBang.state=0;
  gravityBang.state=1;
  helpBang.state=1;
  backgroundBang.state=0;
  setGlobal(1,0,1);
  setSLSF(0,0,0,1);
  tutButtonArray[9].state=0;

  for (int i = 0; i<numSine; i++){
    fv(i,i+1);
    pv(i,0);
    av(i,100);
    dfv(i,0);
    dav(i,0);
    dpv(i,0);
  }
}

public void randomSpace(){
  for(int i = 0; i< numSine; i++){
    fv(i, random(1,40));
    pv(i, random(-3.14f, 3.14f));
    av(i, random(100));
  }

}

public void randomTime(){
  for(int i = 0; i< numSine; i++){
    dfv(i, random(10));
    dpv(i, random(10));
    dav(i, random(10));
  }
}

public void betterRandomSpace(){

  int r = PApplet.parseInt(random(1));


    for(int i = 0; i< numSine; i++){
    fv(i, random(1,40));
    pv(i, random(-3.14f, 3.14f));
    av(i, random(100));
  }
}


public float[] minMaxMinMax(){
  float minVal = random(0,100);
  float maxVal = random(0,100);
  int   period = PApplet.parseInt(random(2,5));
  float[] sValues = new float[40]; // largest number of sines
  for (int i = 0; i < sValues.length; i++){
    if(i % period == 0){sValues[i] = minVal;}
    else               {sValues[i] = maxVal;}
  }
  return sValues;

}


public float[] sinusoidalVals(float minVal, float maxVal){
    float[] sValues = new float[40];
    float tempFreq= random (0.5f, 6);
    float randomPhase = random(0, 3.14f);
    

   for (int i = 0; i < sValues.length; i++){
    sValues[i] = cos((tempFreq * i *6.28f/sValues.length)+randomPhase);
    sValues[i] = map(sValues[i], -1, 1, minVal, maxVal);
    
  }
  return sValues;
}

public float[] severalOn(float minVal, float maxVal){
  float[] sValues = new float[40];
  float r1 = random(1);
  int numOn;
  if      (r1 < 0.2f){numOn = 5;}
  else if (r1 < 0.4f){numOn = 4;}
  else if (r1 < 0.6f){numOn = 3;}
  else if (r1 < 0.8f){numOn = 2;}
  else              {numOn = 1;}

  for (int i = 0; i < numOn; i++){
    sValues[(int)random(0,40)] = random(minVal, maxVal);
  }
  return sValues;

}

public float[] equalValues(float minVal, float maxVal){
  float[] sValues = new float[40];
  float r1 = random(minVal, maxVal);
  for(int i = 0; i<sValues.length; i++){
    sValues[i] = r1;
  }
  return sValues;
}


// This runs when spacebar is pressed.
public void randomRoulette(){


  float[] ampVals = new float[40];
  float[] freqVals = new float[40];
  float[] phaseVals = new float[40];
// float[] dAmpVals = new float[40];
 // float[] dFreqVals = new float[40];
//  float[] dPhaseVals = new float[40];

// may be  unnecessary .... .... .. 
    int[] fpaSelect = new int[6];



///   AAAAA
///   MMMMM
///   PPPPP
// random amplitudes
// 
float rAmp = random(1);

if (rAmp<0.05f){
  float uniformAmp = random(50,100);
  for ( int i = 0; i<ampVals.length; i++ ){
    ampVals[i] = uniformAmp;
  }
} else if(rAmp<0.85f){
ampVals = sinusoidalVals(0,100);

} else if (rAmp<1){
    for ( int i = 0; i<ampVals.length; i++ ){
    ampVals[i] = 100.0f/(i+1);
  }
}



/// FFFFF
/// RRRRR
/// EEEEE
/// QQQQQ
//
//  RANDOM FREQUENCY
float rFreq = random(1);
if(rFreq<0.05f) {
  for ( int i = 0; i<freqVals.length; i++ ){
    freqVals[i] = random(1,40);
  }
} else if (rFreq< 0.2f){
     float tempFreqVal = random(1,40);
    for ( int i = 0; i<freqVals.length; i++ ){
    freqVals[i] = tempFreqVal;
  }
     if(random(1) < 0.75f){
        for ( int i = 0; i<freqVals.length; i++ ){
           freqVals[i] *= random(0.95f,1.05f);
         }
     }
} else if (rFreq < 0.3f){
    for ( int i = 0; i<freqVals.length; i++ ){
   freqVals[i] = numSine - i;
   if(random(1)<0.15f){
    freqVals[i] *= random(0.8f,1.2f);
   }
 }
}


else if (rFreq<1.00f){

  for ( int i = 0; i<freqVals.length; i++ ){
   freqVals[i] = i+1;
   if(random(1)<0.15f){
    freqVals[i] *= random(0.8f,1.2f);
   }
 }
}



// RANDOM PHASE
// 
//                PPPPPPP
//                PP    PP
//                PPPPPPP
//                PP
//                PP
//                PP

float rPhase = random(1);
if(rPhase<0.05f) {
  for ( int i = 0; i<phaseVals.length; i++ ){
    phaseVals[i] = random(-6.28f,6.28f);
  }
} else if (rFreq < 0.15f){
    for ( int i = 0; i<phaseVals.length; i++ ){
    phaseVals[i] = 0;
  }
} else if (rFreq<1.00f){

 phaseVals = sinusoidalVals(-3.14f, 3.14f);
  for ( int i = 0; i<phaseVals.length; i++ ){
   if(random(1)<0.25f){
    phaseVals[i] *= random(0.8f,1.2f);
   }
 }
}


  



///////////////////////////
///////////////////////////
//
// Random colors colors
float r12 = random(1);
if (r12 < 0.7f){
  randomColor12small();

} else {
  randomColor12();


}

float r34 = random(1);

if (r34 < 0.1f){
  setColor3(0,0,0);
  setColor4(0,0,0);
}
else if(r34 < 0.7f){
  randomColor34small(8);
  setColor4(0,0,0);


} else if (r34 < 0.9f){
  randomColor34();
  setColor4(0,0,0);
} else {
  randomColor34();
  setColor4(random(-10,10), random(-10,10), random(-10,10));
}

randomDeltaFreq();
randomDeltaPhase();
randomDeltaAmp();


randomGlobalFreq();
randomSamples();
// turn lights off after a while randomly....
if(random(1)<0.01f){
  backgroundBang.state = 1;
}

// Assign values
for (int i = 0; i < numSine; i++){
  av(i,ampVals[i]);
  fv(i, freqVals[i]);
  pv(i, phaseVals[i]);
  //dav(i,dAmpVals[i]);
  //dfv(i, dFreqVals[i]);
 // dpv(i, dPhaseVals[i]);

}



autoAdjustGlobalAmp();
setSLSF(0,0,0,1);
randomLineStroke();
randomSumFill();
}// end of randomRoulette

////
////
////
///


public void autoAdjustGlobalAmp(){
  float ampAdjust = 0;
  float ampFull = 100 * numSine;
  for(int i = 0; i<numSine; i++){
    float ampAdjustIndividual;
    if (deltaAmpSliderControl.sliders[i].getValue() == 0){
      ampAdjustIndividual = 1;
    } else {
      ampAdjustIndividual = 0.5f;
    }
   ampAdjust += ampSliderControl.sliders[i].getValue() * ampAdjustIndividual;
  }
  
  ampAdjust /= ampFull;
  ampAdjust =1/ampAdjust;
  ampAdjust *= random(0.85f, 1.3f);

  globalAmp.setValue(ampAdjust);

  //println(ampAdjust);
}

public void randomGlobalFreq(){
  float rGF = PApplet.parseInt(random(10));
 // println(rGF);

  if (rGF == 0){
    globalFreq.setValue(0.25f);
  } else if(rGF == 1){
     globalFreq.setValue(0.5f);
  }  else if(rGF == 2){
     globalFreq.setValue(4);
  }  else if(rGF == 3){
     globalFreq.setValue(2);
  }  else if(rGF == 4){
     globalFreq.setValue(3);
  }  else {
     globalFreq.setValue(1);
  }

}

public void randomSamples(){
  float rSamp = random(1);
  if (rSamp< 0.01f){
    binSlider.setValue(0);  // 8
  } else if (rSamp < 0.03f) {
    binSlider.setValue(1); // 16
  } else if (rSamp < 0.06f) {
    binSlider.setValue(2); // 25
  } else if (rSamp < 0.09f) {
    binSlider.setValue(3); // 50
  } else if (rSamp < 0.12f) {
    binSlider.setValue(4); // 100
  } else if (rSamp < 0.15f) {
    binSlider.setValue(5); // 160
  } else if (rSamp < 0.20f) {
    binSlider.setValue(6); // 200
  } else if (rSamp < 0.60f) {
    binSlider.setValue(7); // 16
  } else  {
    binSlider.setValue(8); // 16
  }


}

public void randomDeltaPhase(){
  float[] dPhaseVals = new float[40];
  float rDP = random(1);
  if        (rDP < 0.4f){
       // do nothing...
  } else if (rDP < 0.5f){
    dPhaseVals = equalValues(-10,10);
  } else if (rDP < 0.7f) {
    dPhaseVals = severalOn(-10,10);
  } else if (rDP < 1){
    dPhaseVals = sinusoidalVals(random(-10,10), random(-10,10));
  } 


   for(int i =0; i<numSine; i++){
    dpv(i,dPhaseVals[i]);
   }

}


public void randomDeltaFreq(){
  float[] dFreqVals = new float[40];
  float rDF = random(1);
  if (rDF < 0.4f){
    //do nothing;
  } else if (rDF < 0.45f){
    dFreqVals = equalValues(0,10);
      for(int i = 0; i<dFreqVals.length; i++){
      dFreqVals[i] *= random(0.98f, 1.02f); 
    }
  } else if (rDF < 0.7f) {
    dFreqVals = severalOn(0,10);
  } else {
     dFreqVals = sinusoidalVals(random(0,10), random(0,10));
  }
     for(int i =0; i<numSine; i++){
    dfv(i,dFreqVals[i]);
   }

}

public void randomDeltaAmp(){
  float[] dAmpVals = new float[40];
  float rDA = random(1);
  if (rDA < 0.4f){
    //do nothing;
  } else if (rDA < 0.5f){
    dAmpVals = equalValues(0,10);
    for(int i = 0; i<dAmpVals.length; i++){
      dAmpVals[i] *= random(0.98f, 1.02f); 
    }
  } else if (rDA < 0.7f) {
    dAmpVals = severalOn(0,10);
  } else {
     dAmpVals = sinusoidalVals(random(0,10), random(0,10));
  }
     for(int i =0; i<numSine; i++){
    dav(i,dAmpVals[i]);
   }

}

public void randomSumFill(){
 // setSLSF(0,0,0,1);
  float rSLSF = random(1);

  if(rSLSF < 0.01f){
    setSLSF(1,0,0,1);
  } else if (rSLSF < 0.02f){
    setSLSF(1,0,0,0);
  }
}

public void randomLineStroke(){
 // setSLSF(0,0,0,1);
  float r1 = random(1);
  //float r2 = random(1);

  if(multSampSine() < 2001 && binSlider.getValue() < 6 && r1 <0.1f ){
    setSLSF(1,1,1,0);
  } else if (multSampSine() < 3001 && binSlider.getValue() < 6 && r1<0.2f ){
          float r2 = random(1);
          if(r2<0.75f){
            setSLSF(0,0,1,0);
          } else {
             setSLSF(1,0,1,0);
      
          }

   
  } else if (multSampSine() < 2001 && r1 < 0.4f){
          float r2 = random(1);
          if(r2<0.75f){
            setSLSF(0,1,0,0);
          } else {
             setSLSF(1,1,0,0);
      
          } 
  }

}

// used in picking random Line-Stroke display options
public float multSampSine(){

   float a = binValues[(int)binSlider.pValue];     // Samp...
   float b = numSineValues[(int)numSlider.pValue]; // Sine...
   float c = a * b;
  // println(c);
   return c;

}

//------------------------------------
//  Hide functions

public void hideFrameBox(){
  showFrameBox = false;
}

public void hideBinsBox(){
  showBinsBox = false;
}

public void hideNumBox(){
  showNumBox = false;
}

public void hideGlobalSliders(){
  showGlobalSliders = false;
}

public void hideButtons(){
  showButtons = false;
}

public void hideButtons2(){
  showButtons2 = false;
}



public void hideTut(){
  showTut = false;
}

public void hideColorSliders(){
  showColorSliders = false;
}

public void hideTutButtons(){
  showTutButtons = false;

}

public void hideColor1(){
  showColor1 = false;
}
public void hideColor2(){
  showColor2 = false;
}
public void hideColor3(){
  showColor3 = false;
}
public void hideColor4(){
  showColor4 = false;
}
public void hideAllColor(){
  hideColor1();
  hideColor2();
  hideColor3();
  hideColor4();
}


public void hideFreq(){
  showFreq = false;
}
public void hidePhase(){
  showPhase = false;
}
public void hideAmp(){
  showAmp = false;
}
public void hideDeltaFreq(){
  showDeltaFreq = false;
}
public void hideDeltaPhase(){
  showDeltaPhase = false;
}
public void hideDeltaAmp(){
  showDeltaAmp = false;
}

public void hideSpaceLabel(){
  showSpaceLabel = false;
}

public void hideTimeLabel(){
  showTimeLabel = false;
}

public void hideSines(){
  showSines = false;
}

public void hideSpace(){
  hideFreq();
  hidePhase();
  hideAmp();
  hideSpaceLabel();
}

public void hideTime(){
  hideDeltaFreq();
  hideDeltaPhase();
  hideDeltaAmp();
  hideTimeLabel();
}

public void hideSpaceButtonsime(){
  hideSpace();
  hideTime();
}

public void hideSpaceButtons(){
  ampSliderControl.buttonsOff();
  phaseSliderControl.buttonsOff();
  freqSliderControl.buttonsOff();
}

public void hideTimeButtons(){
  deltaAmpSliderControl.buttonsOff();
  deltaPhaseSliderControl.buttonsOff();
  deltaFreqSliderControl.buttonsOff();

}




public void resetHideBooleans(){
  showFrameBox = true;
  showBinsBox = true;
  showNumBox = true;
  showGlobalSliders = true;
  showButtons = true;
  showButtons2 = true;
  showColorSliders = true;
  showTutButtons = true;
  showTut = true;
  showSines = true;

 showColor1 = true;
 showColor2 = true;
 showColor3 = true;
 showColor4 = true;
 showFreq = true;
 showPhase = true;
 showAmp = true;
 showDeltaFreq = true;
 showDeltaPhase = true;
 showDeltaAmp = true;
 showTimeLabel = true;
 showSpaceLabel = true;
}

public void hideAllControls(){
      hideFrameBox();
      hideBinsBox();
      hideNumBox();
      hideGlobalSliders();
      hideButtons();
      hideButtons2();
//
      hideTutButtons();
      hideTut();
      hideColor1();
      hideColor2();
      hideColor3();
      hideColor4();

      hideSpace();
      hideTime();
      
}


/* This SliderBar class is a pared down and modified version of the "sliderBar Class" by Alejandro Dirgan,
licensed under Creative Commons Attribution-Share Alike 3.0 and GNU GPL license.
Work: http://openprocessing.org/visuals/?visualID= 59987  
License: 
http://creativecommons.org/licenses/by-sa/3.0/
http://creativecommons.org/licenses/GPL/2.0/
*/
 
 
class SliderBar
{
  
  int[] labelArray; 
  boolean useLabelArray = false;
 
  boolean showSlider = true; // When set to false, the slider bar will not be visible and will not update.
  boolean flashing = false;

  int backgroundColor;
  int foregroundColor;
  int foregroundColor2;

  int backgroundColorDay;
  int foregroundColorDay;
  int foregroundColor2Day;
  int labelColorDay; 
  int backgroundColorNite;
  int foregroundColorNite ;
  int foregroundColor2Nite ;
  int labelColorNite;
    
  int borderColor=0;
  int numbersColor;
  int labelColor;
   
  boolean backgroundVisible=true;  // the background is the grey rectangle that is behind the "controller" rectangle
  
  int labelSize=12;
  int numberSize=14;
  boolean visibleText=true;
  boolean visibleNumbers=false;
  boolean secondaryValues = false;
  boolean rightClickReset = false;
   
  int pX, pY, pW, pH;
   
  float pScaled=0, pValue=0;  // Primary value
  float pScaled2=0, pValue2=0; // Secondary value
  float resetValue;            // Value to set slider to if it is reset (if rightClickReset = true)

  int adjustValue = 4; //Default: 4. This accounts for the width of the slider 
   
  //String ID;
   
  boolean debug=false;
  boolean pressOnlyOnce=true;
  int deb=0;
   
  float vMin=0, vMax=15;
   
  int O_HOR=1;
  int O_VER=2;
   
  int orientation=O_HOR;

  Flash horzFlash, vertFlash;
  String helpText = "";
  String helpTitleText = "";
  String labelText = "";
  float labelWidth;//
   
  SliderBar(int x, int y, int w, int h, float iValue, float fValue)
  {
     pX=x;
     pY=y;
     pW=w;
     pH=h;
     
      
     setLimits(iValue, fValue);

      backgroundColorDay = color(0,0,90);
      foregroundColorDay = color(0,0,70);
      foregroundColor2Day = color(0,0,80);
      labelColorDay = color (0, 0, 0);
      
      backgroundColorNite = color(0,00,20);
      foregroundColorNite = color (0,0,50);
      foregroundColor2Nite = color (0,0,25);
      labelColorNite = color (0, 0, 100);

      numbersColor= color (0, 100, 100);

      horzFlash = new Flash(pX, pY, pW, pH, 4, 50, 100, 100);
      vertFlash = new Flash(pX, pY, pH, pW, 4, 50, 100, 100);
         
  }
 

////////////////////////////
///////////////////////////


public void setHelpText(String helpTitleText_, String helpText_){
    helpTitleText = helpTitleText_;
    helpText = helpText_;
}

public void drawToolTip(){

if (backgroundBang.state==0){
    fill(0,0,80);
} else {
    fill(0,0,40);
}

textFont(helpTitleFont);
textAlign(LEFT, TOP);
text(helpTitleText, helpX + 10, helpY, helpW - 10, helpH);

float titleWidth = textWidth(helpTitleText); 

if (backgroundBang.state==0){
    fill(0,0,0);
} else {
    fill(0,0,100);
}

textFont(helpFont);
//text(helpText_, helpX, helpY, helpW, helpH);
textAlign(LEFT, TOP);
textLeading(16);
text(helpText, helpX + titleWidth + 25 ,helpY + 4,helpW - titleWidth - 25 - 10, helpH );

}



public void hide(){
    showSlider = false;
}

public void flashOn(){
    flashing = true;
}




public void chooseColors(){
  if (backgroundBang.state == 0) {
      foregroundColor = foregroundColorDay;
      foregroundColor2 = foregroundColor2Day;
      backgroundColor = backgroundColorDay;
      labelColor = labelColorDay;

  } else {
      foregroundColor = foregroundColorNite;
      foregroundColor2 = foregroundColor2Nite;
      backgroundColor = backgroundColorNite;
      labelColor = labelColorNite;
  }


}



  ////////////////////////////////////////////////////////
  public float getValue()
  {
    return pValue;
  }

  public float getValue2()
  {
    return pValue2;
  }
   
   
  ////////////////////////////////////////////////////////

  public void setOrientation(int o)
  {
    if (o<1) o=1;
    if (o>2) o=2;
     
    orientation=o;
  }
  ////////////////////////////////////////////////////////
  public void setLimits(float iv, float fv)
  {
     vMin=iv;
     vMax=fv;    
      
     setValue(iv);
     setValue2(iv);
      
  }


  ////////////////////////////////////////////////////////
  public void showLabel()
  {
    visibleText=true;
  }
  ////////////////////////////////////////////////////////
  public void hideLabel()
  {
    visibleText=false;
  }
  ////////////////////////////////////////////////////////
  public void showNumbers()
  {
    visibleNumbers=true;
  }
  ////////////////////////////////////////////////////////
  public void hideNumbers()
  {
    visibleNumbers=false;
  }
   
  ////////////////////////////////////////////////////////
  /*
  private float round2nDecimals(float number, float decimal) {
      return (float)(round((number*pow(10, decimal))))/pow(10, decimal);
  } 
  */
  ////////////////////////////////////////////////////////



 public void setTwoValuesOn() {
  secondaryValues = true;
 }
 public void setTwoValuesOff() {
  secondaryValues = false;
 }
 public void rightClickResetOn(){
  rightClickReset = true;
 }
 public void rightClickResetOff(){
  rightClickReset = false;
 }

public void rightClickResetFunction(float value_){
  pValue = value_;
}
public void setResetValue(float value_){
  resetValue = value_;
}

public void labelsFromArray(int[] array_){
  labelArray = array_;
  useLabelArray = true;
}

  ///////////////////////////////////////////////////////
  private boolean mouseOver()
  {
    boolean result=false;
     
     
    if (orientation==O_HOR)
    {
       if (mouseX>=pX && mouseX<=pX+pW && mouseY>=pY && mouseY<=pY+pH)
         result=true;
    }
    else 
         if (mouseX >= pX && mouseX<=pX+pH && mouseY>= pY  &&  mouseY <= pY+pW ) 
         result=true;
     
    return result;
  }
  ///////////////////////////////////////////////////////
  

public void setupTextLabels(){
  
      fill(labelColor);
      textSize(labelSize);
      textAlign(CENTER);

  if (useLabelArray == true){
    labelText = str(labelArray[PApplet.parseInt(pValue)]);
  } else {
    labelText = str((int)pValue);
  }

  labelWidth = textWidth(labelText);


}

  private void drawText()
  {
  fill(labelColor);
    if (visibleText)
    {

      if (orientation==O_HOR){
         text(labelText,pX+pW/2,pY+pH/2+labelSize/2-2);} 
   
       
      else // vert orientation 
      {  text(labelText,pX+pH/2, pY+pW/2 +labelSize/2-2);
           
      }
    }
      
  }

/*

  private void drawText()
  {
    if (visibleText)
    {
      fill(labelColor);
      textSize(labelSize);
      textAlign(CENTER);
      if (orientation==O_HOR){
        if (useLabelArray == true){

          text(str(labelArray[int(pValue)]), pX+pW/2,pY+pH/2+labelSize/2-2);
        } else {
          text(str((int )pValue),pX+pW/2,pY+pH/2+labelSize/2-2);} 
        }
       
      else // vert orientation 
      {
        if (useLabelArray == true){
              text(str(labelArray[int(pValue)]), pX+pH/2, pY+pW/2 +labelSize/2-2);
          } else {
              text(str((int)pValue),pX+pH/2, pY+pW/2 +labelSize/2-2);
          }
   
        

      }
    }
      
  } */
  ///////////////////////////////////////////////////////
  private void drawVerticalBar()
  {
    if (backgroundVisible)
    {
      fill(backgroundColor);
      noStroke();
      //rect(pX + 3*pH/8 ,pY,pH/4,pW);
      rect(pX, pY, pH, pW);
    }
  
   
 
   
   if(secondaryValues) {
    fill(foregroundColor2);
    noStroke();
    rect(pX, pY+pScaled2, pH, 5);
    
   }


      
 


      if (flashing){
        vertFlash.display();
      }
   

      fill(foregroundColor);
      noStroke();
   // This is the "indicator" on the slider
     //textSize(labelSize);

     rect(pX, pY + pScaled, pH, 5);

    
 


    
 
     
 
  }
  ///////////////////////////////////////////////////////
  private void drawHorizontalBar()
  {
    
    if (backgroundVisible)
    {
     fill(backgroundColor);
     noStroke();
      rect(pX, pY, pW, pH); 
    }
   

    if(secondaryValues) {
    fill(foregroundColor2);
    noStroke();
    rect(pX+pScaled2, pY, 5, pH);
    
   }

      if (flashing){
        horzFlash.display();
      }
   

    fill(foregroundColor);
    noStroke();
    rect(pX+pScaled, pY, 5, pH);
  // rect(pX+pScaled, pY, labelWidth, pH);
    
       
       
    
  }
  ///////////////////////////////////////////////////////
  private void drawBar()
  {
     
    if (orientation==O_HOR) drawHorizontalBar();
    if (orientation==O_VER) drawVerticalBar();
     
     
  }
   
  ///////////////////////////////////////////////////////
  public  void setValue(float value)
   {



      if (value>vMax) value=vMax;
      if (value<vMin) value=vMin;
      pValue=value;
      if (orientation==O_HOR)
        pScaled=map(pValue,vMin,vMax,0,pW-adjustValue);
      else
        pScaled=map(pValue,vMin,vMax,pW-adjustValue,0);
   }


   public  void setValue2(float value)
 {
    if (value>vMax) value=vMax;
    if (value<vMin) value=vMin;
    pValue2=value;
    if (orientation==O_HOR)
      pScaled2=map(pValue2,vMin,vMax,0,pW-adjustValue);
    else
      pScaled2=map(pValue2,vMin,vMax,pW-adjustValue,0);
 }
    
  ///////////////////////////////////////////////////////
  private void checkMouse()
  {
    if (debug)
    {
      if (mouseOver()  && keyPressed && mouseButton==LEFT && mousePressed)
      {
        if (keyCode==CONTROL)
        {
          pX=pX+mouseX-pmouseX;
          pY=pY+mouseY-pmouseY;
        }
        if (keyCode==SHIFT && pressOnlyOnce)
        {
          pressOnlyOnce=false;
        }
        deBounce(3);
      }
       
    }
  } 
  ///////////////////////////////////////////////////////
  private void checkKeyboard()
  {
     if (mouseOver())
     {
       
       if (mousePressed && mouseButton==LEFT)
       {
         if (orientation==O_HOR)
           pValue=(float)map((mouseX-pX),0,pW-adjustValue,vMin,vMax);
         else
           pValue=(float)map((mouseY-pY),pW-adjustValue,0,vMin,vMax);
             
         if (pValue>vMax) pValue=vMax;
         if (pValue<vMin) pValue=vMin;
       }


       if (mousePressed && mouseButton==RIGHT && rightClickReset==false){

     
       
         if (orientation==O_HOR)
           pValue2=(float)map((mouseX-pX),0,pW-adjustValue,vMin,vMax);
         else
           pValue2=(float)map((mouseY-pY),pW-adjustValue,0,vMin,vMax);
             
         if (pValue2>vMax) pValue2=vMax;
         if (pValue2<vMin) pValue2=vMin;
       }
       
       
      if (mousePressed && mouseButton==RIGHT && rightClickReset==true){
       rightClickResetFunction(resetValue);
      }
 
 
       if (keyPressed && pressOnlyOnce)
       {
         if (keyCode==LEFT || keyCode==DOWN) pValue--;
         if (keyCode==RIGHT || keyCode==UP) pValue++;
         if (pValue>vMax) pValue=vMax;
         if (pValue<vMin) pValue=vMin;
         pressOnlyOnce=false;
       }
       deBounce(5);
 

       if (orientation==O_HOR){
         pScaled=map(pValue,vMin,vMax,0,pW-adjustValue);
         pScaled2=map(pValue2, vMin, vMax,0, pW-adjustValue);
       }
       else {
         pScaled=map(pValue,vMin,vMax,pW-adjustValue,0);
         pScaled2=map(pValue2, vMin, vMax, pW-adjustValue, 0);
       }
        


        
     }
   } 
  ///////////////////////////////////////////////////////
  private void change()
  {
    checkKeyboard();
    checkMouse();
  }
  ///////////////////////////////////////////////////////
  public float update() {

        chooseColors();
     if (showSlider){
        setupTextLabels();
        drawBar();
        drawText();

        if(mouseOver() &&  helpBang.state==1){
         drawToolTip();
        }
      }
        change();

    

    showSlider = true;   
    flashing = false;
    return pValue; 

  }
  ///////////////////////////////////////////////////////
 

 
/////////////////////////////////////////////////////// 
  private void deBounce(int n)
  {
    if (pressOnlyOnce)
      return;
    else
       
    if (deb++ > n)
    {
      deb=0;
      pressOnlyOnce=true;
    }
     
  }   
  /////////////////////////////////////////////////////// 



   
}


// Sometimes I wonder if there's anything more to life than just sine waves... 
// This function calculates the average values of a slider array, and then averages each value with the overall average.


class SliderControl {

BangButton  minus, explode, collapse,  plus;
BangButton labelButton;

boolean showButtons = true;

int x, y, h;
int w1, w2, w3, w4;
int yButton;

SliderBar[] sliders;
int numSliderBar;
float setValue;
float[] newValues;
float minimum, maximum;
String label;
int hSpace, wSpace;
int numValues;
float resetValue;

float sliderLength;
float sliderWidth;
int sliderWidth30, sliderWidth40, sliderWidthNorm, sliderWidth40odd;

int labelTextColor, labelBackgroundColor, buttonTextColor, minusColor, explodeColor, collapseColor, plusColor;

    int numStates = 1;



int prevMinus, prevPlus, prevExplode, prevCollapse;


   SliderControl (int x_, int y_, float min_, float max_, int numSliderBar_, float setValue_, String label_, int numValues_, float resetValue_){

     x = x_;
     y = y_;
     minimum = min_;
     maximum = max_;

     numValues=numValues_;

     numSliderBar = numSliderBar_;
     setValue = setValue_;

     label = label_;
     resetValue = resetValue_;
      
    sliders = new SliderBar[numSliderBar];
    newValues = new float[numSliderBar];
     
     w1 = 18;
     w2 = 19;
     w3 = 19;
     w4 = 18;

     h = 18;

     sliderLength = 74;

     sliderWidthNorm = 20;
     sliderWidth30 = 17;
     sliderWidth40 = 12;
     sliderWidth40odd = 13;


    int prevMinus, prevPlus, prevExplode, prevCollapse;



    wSpace = 0;
    hSpace = 10;
    
    
     for (int i = 0;  i < numSliderBar; i++){
      if(numSliderBar==40){
        sliderWidth = sliderWidth40;
      } else if (numSliderBar==30) {
        sliderWidth = sliderWidth30;
      } else {
        sliderWidth = sliderWidthNorm;
      }


           sliders[i] = new SliderBar(x, PApplet.parseInt(floor(baselines[i]) - floor(boxHeight/2) - sliderWidth/2) + sinesTranslateY, PApplet.parseInt(sliderLength), PApplet.parseInt(sliderWidth), minimum, maximum);
           if(numSliderBar==40 && i%2==0){//make the even indexed slider bars 1 pixel wider to have even gaps between sliders. (for aesthetics).
            sliders[i] = new SliderBar(x, PApplet.parseInt(floor(baselines[i]) - floor(boxHeight/2) - sliderWidth/2) + sinesTranslateY, PApplet.parseInt(sliderLength), PApplet.parseInt(sliderWidth40odd), minimum, maximum);

           }

           sliders[i].setOrientation(1);
           sliders[i].setValue(setValue);
           //sliders[i].setHelpText(label,"This slider controls the " + label + " of sine number " + (i+1)+". It ranges from " + minimum +" to " + maximum +". \nRight-click to reset value to " + resetValue+"." );
           if (numValues==2){
            sliders[i].setTwoValuesOn();
           } else if (numValues == 1) {
            sliders[i].rightClickResetOn();
            sliders[i].setResetValue(resetValue);
           } else {
            sliders[i].rightClickResetOn();
            sliders[i].setResetValue(i+1);

           }
        }
   
    yButton = PApplet.parseInt(baselines[numSliderBar-1] - boxHeight/2 - sliderWidth/2) + sinesTranslateY - hSpace - h;
    
    minus = new BangButton(x, yButton , w1, h, "", numStates);
    explode =  new BangButton(x + w1 + wSpace, yButton, w2, h, "", numStates);
    collapse = new  BangButton(x + w1 + w2 + 2*wSpace, yButton, w3, h, "", numStates);
    plus =  new BangButton(x + w1+w2+w3 + 3*wSpace, yButton, w4, h, "", numStates);

    labelButton = new BangButton(PApplet.parseInt(x), yButton - 20, w1+w2+w3+w4, 20, "",numStates);


     updateColors();
     
     minus.setHelpText("-", "Minus decreases the value of all sliders in this column by an equal amount.");
     explode.setHelpText(")(", "Expand randomly steps each slider in this column up or down.\nThis is useful for making sines slightly out of sync with each other.");
     collapse.setHelpText("()", "Collapse calculates the average of all the sliders in this column, then moves each slider half the distance to the average. This is useful for bring sines in sync.");
     plus.setHelpText("+", "Plus increases the value of all sliders in this column by an equal amount.");

   }//end constructor




//////++++++++++++++++++++++++++++++++++++++++++++++++++++++++ begin function
  // FUNCTION 
   public void update(){

    updateColors();

  //textAlign(CENTER);
 // fill(0,0,0);
  //text(label, x+sliderLength/2, yButton - 5);


     for (int i  = 0; i < numSliderBar; i ++){
       sliders[i].update();
 }

 
  if (showButtons){
     minus.update();
    explode.update();
    collapse.update();
    plus.update();
  }

  labelButton.update();
    





   


 if (collapse.toggleCount != prevCollapse) { 
    updatePrevious(); 

    newValues = collapseEval(sliderValuesArray());

    for (int i = 0; i < sliders.length; i++){
      sliders[i].setValue(newValues[i]);
    }  
     

 }



 else if (plus.toggleCount != prevPlus)   {
 updatePrevious();  
 newValues = plusEval(sliderValuesArray());

 for (int i = 0; i<sliders.length; i++){
   sliders[i].setValue(newValues[i]);
 }
}
 



 else if ( explode.toggleCount != prevExplode)  { 
     updatePrevious();

     newValues = explodeEval(sliderValuesArray());

     for (int i = 0; i < sliders.length; i++){
       sliders[i].setValue(newValues[i]);
     }
 }



 else if (minus.toggleCount != prevMinus) {
  updatePrevious();
  newValues = minusEval(sliderValuesArray());

  for (int i = 0; i < sliders.length; i++){
    sliders[i].setValue(newValues[i]);

  }
}
 
 else {updatePrevious();   sliderValuesArray();}


 //showButtons = true;

 }/////-------------------------------------------------------- end update



 public void updateColors(){

      // lights on color
     if (backgroundBang.state==0) {
      labelTextColor = color(0,0,0);
      labelBackgroundColor = color(0,0,100, 0);

      buttonTextColor = color(0,0,0);

      minusColor = color (150, 10, 100);
      explodeColor = color(200, 10, 100);
      collapseColor = color(240, 10, 100);
      plusColor = color(270, 10, 100);

     } else {

      // lights off color
      labelTextColor = color(0,0,100);
      labelBackgroundColor = color(0,50,1,0);

      buttonTextColor = color(0,0,100);

      minusColor = color (150, 50, 40);
      explodeColor = color(200, 50, 40);
      collapseColor = color(240, 50, 40);
      plusColor = color(270, 50, 40);
     }

    minus.setState(0, 0, "-", minusColor, buttonTextColor);
    explode.setState(0, 0, ")(", explodeColor, buttonTextColor);
    collapse.setState(0, 0, "()", collapseColor, buttonTextColor);
    plus.setState(0, 0, "+", plusColor, buttonTextColor);
    labelButton.setState(0,0, label, labelBackgroundColor, labelTextColor);

 }



  public void updatePrevious(){
    prevMinus = minus.toggleCount;
    prevPlus = plus.toggleCount;
    prevCollapse = collapse.toggleCount;
    prevExplode = explode.toggleCount;
  }


 // This function returns the values of each slider
   public float sliderValues(int index) {
      
    float[] values = new float[sliders.length];

     for (int i = 0; i < sliders.length; i++) {
       values[i] = sliders[i].getValue();
     }

    return values[index];
   }

   public float returnNewValues(int index){
    sliders[index].setValue(newValues[index]);
    return newValues[index];

   }

public float[] sliderValuesArray() {
  float[] values = new float[sliders.length];

  for (int i = 0; i < sliders.length; i++){
    values[i] = sliders[i].getValue();
  }

  return values;
}




public float[] collapseEval (float[] inputs_) {
        float[] inputs = new float[inputs_.length];
        float[] outputs = new float[inputs_.length];

        inputs = inputs_;
        float sum = 0;
        float mean = 0;

        for (int i = 0; i < inputs.length; i++){
            sum += inputs[i];
        }
          
        mean = sum / inputs.length;

        for (int i =0; i < inputs.length; i++){

           outputs[i] = (inputs[i] + mean)/2;
        }

        return outputs;

 } // end average function\


public float[] explodeEval (float[] inputs_) {
  float[] inputs = new float[inputs_.length];
  float[] outputs = new float[inputs_.length];

  inputs = inputs_;
  float sum = 0;
  float mean = 0;

  for (int i = 0; i < inputs.length; i++){
         sum += inputs[i];
  }

  mean = sum / inputs.length;


  for (int i = 0; i < inputs.length; i++){
   outputs[i] = inputs[i] + random(-1,1) * .05f * (maximum - minimum);
  }

  return outputs;
}


public float[] plusEval(float[] inputs_) {
  float[] inputs = new float[inputs_.length];
  float[] outputs = new float[inputs_.length];
  inputs = inputs_;

   for (int i = 0; i < inputs.length; i++){
    outputs[i]  = inputs[i] + .04f * (maximum - minimum);
   }
return outputs;
}


public float[] minusEval(float[] inputs_) {
    float[] inputs = new float[inputs_.length];
    float[] outputs = new float[inputs_.length];
    inputs = inputs_;

   for (int i = 0; i < inputs.length; i++){
    outputs[i]  = inputs[i] - .04f * (maximum - minimum);
   }

   return outputs;
}


public void buttonsOff() {
  showButtons = false;
}

public void buttonsOn(){
  showButtons = true;
}


public void flipValues(){
    float[] tempValues = new float[numSine];
    for (int j = 0; j < numSine; j++){
      tempValues[j] = sliders[j].getValue();
    }
    for (int j = 0; j < numSine; j++){
      sliders[j].setValue(tempValues[numSine-1-j]);
    }
  }

public void setAllToZero(){
  for (int j = 0; j < numSine; j++){
    sliders[j].setValue(0);
  }
}


} // end SliderControl class
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Sum_Some_Sines" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
